/***********************************************************************
 *        FILE: cclib.cpp
 * DESCRIPTION: Cross compatibility Library file for DIALOGIC Windows NT
 *
 *   Copyright (c) 1991-1996 Dialogic Corp. All Rights Reserved
 *
 *   THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF Dialogic Corp.
 *   The copyright notice above does not evidence any actual or
 *   intended publication of such source code.
 **********************************************************************/

#ifndef __CROSS_COMPAT_LIB__
#define __CROSS_COMPAT_LIB__
#endif

#include        <windows.h>
#include        "srllib.h"
#include        "dtilib.h"
#include        "cclib.h"

//
// Function Protoypes
//

static int cc_int_notimp();   
static int cc_int_LINEDEV_notimp(LINEDEV);   
static int cc_int_CRN_notimp(CRN);  

//
// Typedef and defines
//
typedef void (*func_ptr)(void);
struct func_table {
	char *fname;
	func_ptr fptr;
};

#define         cc_AcceptCall_ID           0
#define         cc_AnswerCall_ID           1
#define         cc_CRN2LineDev_ID          2
#define         cc_CallProgress_ID         3
#define         cc_CallState_ID            4
#define         cc_Close_ID                5
#define         cc_Congestion_ID           6
#define         cc_DropCall_ID             7
#define         cc_FacilityAck_ID          8
#define         cc_FacilityRej_ID          9
#define         cc_FacilityReq_ID          10
#define         cc_GetANI_ID               11
#define         cc_GetBilling_ID           12
#define         cc_GetCallInfo_ID          13
#define         cc_GetInfoElem_ID          14
#define         cc_GetCRN_ID               15
#define         cc_GetDNIS_ID              16
#define         cc_GetEvtMsk_ID            17
#define         cc_GetVoiceH_ID            18
#define         cc_GetNetH_ID              19
#define         cc_GetParm_ID              20
#define         cc_GetUsrAttr_ID           21
#define         cc_GetVer_ID               22
#define         cc_GetLineDev_ID           23
#define         cc_MakeCall_ID             24
#define         cc_Open_ID                 25
#define         cc_ReleaseCall_ID          26
#define         cc_ReqANI_ID               27
#define         cc_ResultValue_ID          28
#define         cc_ResultMsg_ID            29
#define         cc_SetBilling_ID           30
#define         cc_SetCallingNum_ID        31
#define         cc_SetChanState_ID         32
#define         cc_SetEvtMsk_ID            33
#define         cc_SetInfoElem_ID          34
#define         cc_SetParm_ID              35
#define         cc_SetUsrAttr_ID           36
#define         cc_StartTrace_ID           37
#define         cc_StopTrace_ID            38
#define         cc_WaitCall_ID             39
#define         cc_CauseValue_ID           40
#define         cc_Restart_ID              41
#define         cc_SndMsg_ID               42
#define         cc_SetMinDigits_ID         43
#define         cc_GetBChanState_ID        44
#define         cc_GetDChanState_ID        45
#define         cc_CallAck_ID              46
#define         cc_GetMoreDigits_ID        47
#define         cc_SndFrame_ID             48
#define         cc_GetFrame_ID             49
#define		cc_HoldAck_ID              50
#define		cc_HoldCall_ID             51
#define		cc_HoldRej_ID              52
#define         cc_RetrieveAck_ID          53
#define         cc_RetrieveCall_ID         54
#define         cc_RetrieveRej_ID          55
#define         cc_BlockTs_ID              56
#define         cc_PutEvt_ID               57
#define         cc_RejectCall_ID           58
#define         cc_UnBlockTs_ID            59
#define         cc_geterror_ID             60
#define         cc_seterror_ID             61
#define         is_GetAllCRN_ID            62
#define         is_internaltest_ID         63
#define         cc_GetSigInfo_ID           64
#define         cc_GetNetCRV_ID            65
#define         cc_SetDChanCfg_ID          66
#define         cc_TermRegisterResponse_ID 67
#define         cc_GetDLinkState_ID        68
#define         cc_GetCES_ID               69
#define         cc_GetSAPI_ID              70
#define         cc_SndNonCallMsg_ID        71
#define         cc_GetNonCallMsg_ID        72
#define		cc_SetParmEx_ID		   73
#define		cc_GetParmEx_ID		   74
#define         cc_ToneRedefine_ID         75
#define         cc_PlayTone_ID             76
#define         cc_StopTone_ID             77
#define         cc_ReleaseCallEx_ID        78
#define		cc_TransferCall_ID	   79	
#define		cc_TransferAck_ID	   80
#define		cc_TransferRej_ID	   81
#define         cc_SetDLinkState_ID        82
#define         cc_SetDLinkCfg_ID          83
#define         cc_GetDLinkCfg_ID          84
#define			cc_Register_ID			   85 

typedef int (*ptr_cc_AcceptCall)(CRN, int, unsigned long);
typedef int (*ptr_cc_AnswerCall)(CRN, int, unsigned long);
typedef int (*ptr_cc_CRN2LineDev)(CRN, LINEDEV *);
typedef int (*ptr_cc_CallProgress)(CRN, int);
typedef int (*ptr_cc_CallState)(CRN, int *);
typedef int (*ptr_cc_Close)(LINEDEV);
typedef int (*ptr_cc_Congestion)(CRN, int);
typedef int (*ptr_cc_DropCall)(CRN, int, unsigned long);
typedef int (*ptr_cc_FacilityAck)(CRN, NFACILITY_ELEM *);
typedef int (*ptr_cc_FacilityRej)(CRN, NFACILITY_ELEM *, int);
typedef int (*ptr_cc_FacilityReq)(CRN, NFACILITY_ELEM *, unsigned long);
typedef int (*ptr_cc_GetANI)(CRN, char *);
typedef int (*ptr_cc_GetBilling)(CRN, char *);
typedef int (*ptr_cc_GetCallInfo)(CRN crn, int info_id, char *valuep);
typedef int (*ptr_cc_GetInfoElem)(LINEDEV ddd, IE_BLK *iep );
typedef int (*ptr_cc_GetCRN)(CRN *, void *);
typedef int (*ptr_cc_GetDNIS)(CRN, char *);
typedef int (*ptr_cc_GetEvtMsk)(LINEDEV, unsigned long *);
typedef int (*ptr_cc_GetVoiceH)(LINEDEV, int *);
typedef int (*ptr_cc_GetNetH)(LINEDEV, int *);
typedef int (*ptr_cc_GetParm)(LINEDEV, int, CC_PARM *);
typedef int (*ptr_cc_GetUsrAttr)(LINEDEV, long *);
typedef int (*ptr_cc_GetVer)(LINEDEV, unsigned int *, unsigned int *);
typedef int (*ptr_cc_GetLineDev)(LINEDEV *, void *);
typedef int (*ptr_cc_MakeCall)(LINEDEV, CRN *, char *,MAKECALL_BLK *, int, unsigned long);
typedef int (*ptr_cc_Open)(LINEDEV *, char *, unsigned short);
typedef int (*ptr_cc_ReleaseCall)(CRN);
typedef int (*ptr_cc_ReqANI)(CRN, char *, int, unsigned long);
typedef int (*ptr_cc_ResultValue)(void *);
typedef int (*ptr_cc_ResultMsg)(LINEDEV, int, char **);
typedef int (*ptr_cc_SetBilling)(CRN, int, CC_RATE_U *, unsigned long);
typedef int (*ptr_cc_SetCallingNum)(LINEDEV, char *);
typedef int (*ptr_cc_SetChanState)(LINEDEV, int, unsigned long);
typedef int (*ptr_cc_SetEvtMsk)(LINEDEV, unsigned long, int);
typedef int (*ptr_cc_SetInfoElem)(LINEDEV, IE_BLK *);
typedef int (*ptr_cc_SetParm)(LINEDEV, int, long);
typedef int (*ptr_cc_SetUsrAttr)(LINEDEV, long );
typedef int (*ptr_cc_StartTrace)(LINEDEV, char *);
typedef int (*ptr_cc_StopTrace)(LINEDEV);
typedef int (*ptr_cc_WaitCall)(LINEDEV, CRN *, WAITCALL_BLK *,int, MODE);
typedef int (*ptr_cc_CauseValue)(LINEDEV);
typedef int (*ptr_cc_Restart)(LINEDEV linedev, unsigned long mode);
typedef int (*ptr_cc_GetMoreDigits)(CRN crn, int num_digits, long timeout, unsigned long mode);
typedef int (*ptr_cc_SetMinDigits)(LINEDEV linedev, int mindigs);
typedef int (*ptr_cc_SndMsg)(CRN crn, int msg_type, IE_BLK *sndmsgptr);
typedef int (*ptr_cc_GetBChanState)(LINEDEV ddd, int *l2stateptr);
typedef int (*ptr_cc_GetDChanState)(LINEDEV ddd, int *l2stateptr);
typedef int (*ptr_cc_CallAck)(CRN crn, LINEDEV new_linedev, int msg_id);
typedef int (*ptr_cc_SndFrame)(LINEDEV linedev, IE_BLK *sndframptr);
typedef int (*ptr_cc_GetFrame)(LINEDEV linedev, L2_BLK *rcvframptr);
typedef int (*ptr_cc_HoldAck)(CRN crn);
typedef int (*ptr_cc_HoldCall)(CRN crn, unsigned long mode);
typedef int (*ptr_cc_HoldRej)(CRN crn, int cause);
typedef int (*ptr_cc_RetrieveAck)(CRN crn);
typedef int (*ptr_cc_RetrieveCall)(CRN crn, unsigned long mode);
typedef int (*ptr_cc_RetrieveRej)(CRN crn, int cause);
typedef int (*ptr_cc_TransferCall)(CRN crn1, CRN crn2, unsigned long mode);
typedef int (*ptr_cc_TransferAck)(CRN crn1);
typedef int (*ptr_cc_TransferRej)(CRN crn1, int nCause);
typedef int (*ptr_cc_BlockTs)(LINEDEV linedev);
typedef int (*ptr_cc_PutEvt)(LINEDEV ddd, long event_type);
typedef int (*ptr_cc_RejectCall)(CRN crn, int cause, unsigned long mode);
typedef int (*ptr_cc_UnBlockTs)(LINEDEV linedev);
typedef int (*ptr_cc_geterror)(void);
typedef int (*ptr_cc_seterror)(int error);
typedef int (*ptr_is_GetAllCRN)( LINEDEV handle, int *num_crn, CRN *crnptr );
typedef int (*ptr_is_internaltest)( CRN crn,  int msgid, int length, char *backdata );
typedef int (*ptr_cc_GetSigInfo)(CHAR *lpValue,INT nInfoID,LPVOID lpVoid);
typedef int (*ptr_cc_GetNetCRV)(CRN crn, int *netcrvp);
typedef int (*ptr_cc_SetDChanCfg) (LINEDEV linedev, DCHAN_CFG *dchan_cfg_ptr);
typedef int (*ptr_cc_TermRegisterResponse) (LINEDEV linedev, TERM_BLK *term_blk_ptr);
typedef int (*ptr_cc_GetDLinkState) (LINEDEV linedev, DLINK *dlinkptr, int *state_buf);
typedef int (*ptr_cc_GetCES) (CHAR *lpValue,LPVOID lpVoid);
typedef int (*ptr_cc_GetSAPI) (CHAR *lpValue,LPVOID lpVoid);
typedef int (*ptr_cc_SndNonCallMsg) (LINEDEV linedev, int crn_type, int msg_type, NONCRN_BLK *noncallmsgptr);
typedef int (*ptr_cc_GetNonCallMsg) (LINEDEV linedev, NONCRN_BLK *noncallmsgptr);
typedef int (*ptr_cc_SetParmEx)(LINEDEV, int, PARM_INFO *);
typedef int (*ptr_cc_GetParmEx)(LINEDEV, int, PARM_INFO *);
typedef int (*ptr_cc_ToneRedefine) (LINEDEV LineDev, unsigned char sigtype, toneParm *pToneParm, MODE Mode);
typedef int (*ptr_cc_PlayTone) (LINEDEV LineDev, toneParm *pToneParm, DV_TPT *tptp, MODE Mode);
typedef int (*ptr_cc_StopTone) (LINEDEV LineDev, MODE Mode);
typedef int (*ptr_cc_ReleaseCallEx)(CRN, MODE nMode);
typedef int (*ptr_cc_SetDLinkState) (LINEDEV linedev, DLINK *dlinkptr, int *state_buf);
typedef int (*ptr_cc_SetDLinkCfg) (LINEDEV linedev, DLINK *dlinkptr, DLINK_CFG *config);
typedef int (*ptr_cc_GetDLinkCfg) (LINEDEV linedev, DLINK *dlinkptr, DLINK_CFG *config);
typedef int (*ptr_cc_Register) (LINEDEV , CRN *, NONCALL_BLK *, unsigned long ); 

//
// Global variables
//
static struct func_table CCFunc[] = {
{ "cc_AcceptCall",            (func_ptr)cc_int_CRN_notimp },
{ "cc_AnswerCall",            (func_ptr)cc_int_CRN_notimp },
{ "cc_CRN2LineDev",           (func_ptr)cc_int_CRN_notimp },
{ "cc_CallProgress",          (func_ptr)cc_int_CRN_notimp },
{ "cc_CallState",             (func_ptr)cc_int_CRN_notimp },
{ "cc_Close",                 (func_ptr)cc_int_LINEDEV_notimp },
{ "cc_Congestion",            (func_ptr)cc_int_CRN_notimp },
{ "cc_DropCall",              (func_ptr)cc_int_CRN_notimp },
{ "cc_FacilityAck",           (func_ptr)cc_int_CRN_notimp }, 
{ "cc_FacilityRej",           (func_ptr)cc_int_CRN_notimp }, 
{ "cc_FacilityReq",           (func_ptr)cc_int_CRN_notimp }, 
{ "cc_GetANI",                (func_ptr)cc_int_CRN_notimp }, 
{ "cc_GetBilling",            (func_ptr)cc_int_CRN_notimp }, 
{ "cc_GetCallInfo",           (func_ptr)cc_int_CRN_notimp }, 
{ "cc_GetInfoElem",           (func_ptr)cc_int_LINEDEV_notimp },    
{ "cc_GetCRN",                (func_ptr)cc_int_notimp },
{ "cc_GetDNIS",               (func_ptr)cc_int_CRN_notimp }, 
{ "cc_GetEvtMsk",             (func_ptr)cc_int_LINEDEV_notimp }, 
{ "cc_GetVoiceH",             (func_ptr)cc_int_LINEDEV_notimp }, 
{ "cc_GetNetH",               (func_ptr)cc_int_LINEDEV_notimp }, 
{ "cc_GetParm",               (func_ptr)cc_int_LINEDEV_notimp }, 
{ "cc_GetUsrAttr",            (func_ptr)cc_int_LINEDEV_notimp }, 
{ "cc_GetVer",                (func_ptr)cc_int_LINEDEV_notimp }, 
{ "cc_GetLineDev",            (func_ptr)cc_int_notimp },
{ "cc_MakeCall",              (func_ptr)cc_int_LINEDEV_notimp }, 
{ "cc_Open",                  (func_ptr)cc_int_notimp },
{ "cc_ReleaseCall",           (func_ptr)cc_int_CRN_notimp }, 
{ "cc_ReqANI",                (func_ptr)cc_int_CRN_notimp }, 
{ "cc_ResultValue",           (func_ptr)cc_int_notimp },
{ "cc_ResultMsg",             (func_ptr)cc_int_notimp }, 
{ "cc_SetBilling",            (func_ptr)cc_int_CRN_notimp }, 
{ "cc_SetCallingNum",         (func_ptr)cc_int_LINEDEV_notimp }, 
{ "cc_SetChanState",          (func_ptr)cc_int_LINEDEV_notimp }, 
{ "cc_SetEvtMsk",             (func_ptr)cc_int_LINEDEV_notimp }, 
{ "cc_SetInfoElem",           (func_ptr)cc_int_LINEDEV_notimp }, 
{ "cc_SetParm",               (func_ptr)cc_int_LINEDEV_notimp }, 
{ "cc_SetUsrAttr",            (func_ptr)cc_int_LINEDEV_notimp }, 
{ "cc_StartTrace",            (func_ptr)cc_int_LINEDEV_notimp }, 
{ "cc_StopTrace",             (func_ptr)cc_int_LINEDEV_notimp }, 
{ "cc_WaitCall",              (func_ptr)cc_int_LINEDEV_notimp }, 
{ "cc_CauseValue",            (func_ptr)cc_int_notimp },
{ "cc_Restart",               (func_ptr)cc_int_LINEDEV_notimp },  
{ "cc_SndMsg",                (func_ptr)cc_int_CRN_notimp },  
{ "cc_SetMinDigits",          (func_ptr)cc_int_LINEDEV_notimp },  
{ "cc_GetBChanState",         (func_ptr)cc_int_LINEDEV_notimp },  
{ "cc_GetDChanState",         (func_ptr)cc_int_LINEDEV_notimp },  
{ "cc_CallAck",               (func_ptr)cc_int_CRN_notimp },  
{ "cc_GetMoreDigits",         (func_ptr)cc_int_CRN_notimp }, 
{ "cc_SndFrame",              (func_ptr)cc_int_LINEDEV_notimp }, 
{ "cc_GetFrame",              (func_ptr)cc_int_LINEDEV_notimp },
{ "cc_HoldAck",               (func_ptr)cc_int_CRN_notimp }, 
{ "cc_HoldCall",              (func_ptr)cc_int_CRN_notimp }, 
{ "cc_HoldRej",               (func_ptr)cc_int_CRN_notimp }, 
{ "cc_RetrieveAck",           (func_ptr)cc_int_CRN_notimp }, 
{ "cc_RetrieveCall",          (func_ptr)cc_int_CRN_notimp }, 
{ "cc_RetrieveRej",           (func_ptr)cc_int_CRN_notimp }, 
{ "cc_BlockTs",               (func_ptr)cc_int_LINEDEV_notimp },
{ "cc_PutEvt",                (func_ptr)cc_int_LINEDEV_notimp },
{ "cc_RejectCall",            (func_ptr)cc_int_CRN_notimp }, 
{ "cc_UnBlockTs",             (func_ptr)cc_int_LINEDEV_notimp },
{ "cc_geterror",              (func_ptr)cc_int_notimp },                 
{ "cc_seterror",              (func_ptr)cc_int_notimp },                 
{ "is_GetAllCRN",             (func_ptr)cc_int_LINEDEV_notimp },
{ "is_internaltest",          (func_ptr)cc_int_CRN_notimp },
{ "cc_GetSigInfo",            (func_ptr)cc_int_notimp },                 
{ "cc_GetNetCRV",             (func_ptr)cc_int_CRN_notimp },                 
{ "cc_SetDChanCfg",           (func_ptr)cc_int_LINEDEV_notimp },
{ "cc_TermRegisterResponse",  (func_ptr)cc_int_LINEDEV_notimp },
{ "cc_GetDLinkState",         (func_ptr)cc_int_LINEDEV_notimp },
{ "cc_GetCES",                (func_ptr)cc_int_notimp },
{ "cc_GetSAPI",               (func_ptr)cc_int_notimp },
{ "cc_SndNonCallMsg",         (func_ptr)cc_int_LINEDEV_notimp },
{ "cc_GetNonCallMsg",         (func_ptr)cc_int_LINEDEV_notimp },
{ "cc_SetParmEx",             (func_ptr)cc_int_LINEDEV_notimp }, 
{ "cc_GetParmEx",             (func_ptr)cc_int_LINEDEV_notimp }, 
{ "cc_ToneRedefine",          (func_ptr)cc_int_LINEDEV_notimp }, 
{ "cc_PlayTone",              (func_ptr)cc_int_LINEDEV_notimp },
{ "cc_StopTone",              (func_ptr)cc_int_LINEDEV_notimp },
{ "cc_ReleaseCallEx",         (func_ptr)cc_int_CRN_notimp },
{ "cc_TransferCall",          (func_ptr)cc_int_CRN_notimp },
{ "cc_TransferAck",           (func_ptr)cc_int_CRN_notimp },
{ "cc_TransferRej",           (func_ptr)cc_int_CRN_notimp },
{ "cc_SetDLinkState",         (func_ptr)cc_int_LINEDEV_notimp },
{ "cc_SetDLinkCfg",           (func_ptr)cc_int_LINEDEV_notimp },
{ "cc_GetDLinkCfg",           (func_ptr)cc_int_LINEDEV_notimp },
{ "cc_Register",              (func_ptr)cc_int_LINEDEV_notimp }   
};

int cc_libinit(HINSTANCE LibHandle)
{
	struct func_table *ccp = CCFunc;
	func_ptr ProcAddress;
	DWORD NumberofFunctions;

	NumberofFunctions = sizeof(CCFunc)/sizeof(CCFunc[0]);

	//
	// The library has been loaded previously. Set up each entry to a default
	// not implemented function and then overwrite the true address if 
	// the function is present in the DLL.
	//

	while (NumberofFunctions --) {
		ProcAddress = (func_ptr)GetProcAddress(LibHandle, ccp->fname);
		if (ProcAddress) {
			ccp->fptr = ProcAddress;
		}
		ccp ++;
	}

	return 0;
}
int cc_AcceptCall(CRN crn, int rings, unsigned long mode)
{
	ptr_cc_AcceptCall p;

	p = (ptr_cc_AcceptCall)*CCFunc[cc_AcceptCall_ID].fptr;
	return (*p)(crn, rings, mode);
}

int cc_AnswerCall(CRN crn, int rings, unsigned long mode)
{
	ptr_cc_AnswerCall p;

	p = (ptr_cc_AnswerCall)*CCFunc[cc_AnswerCall_ID].fptr;
	return (*p)(crn, rings, mode);
}

int cc_CRN2LineDev(CRN crn, LINEDEV *linedevp)
{
	ptr_cc_CRN2LineDev p;

	p = (ptr_cc_CRN2LineDev)*CCFunc[cc_CRN2LineDev_ID].fptr;
	return (*p)(crn, linedevp);
}

int cc_CallProgress(CRN crn, int indicator)
{
	ptr_cc_CallProgress p;

	p = (ptr_cc_CallProgress)*CCFunc[cc_CallProgress_ID].fptr;
	return (*p)(crn, indicator);
}
int cc_CallState(CRN crn, int *state_ptr)
{
	ptr_cc_CallState p;

	p = (ptr_cc_CallState)*CCFunc[cc_CallState_ID].fptr;
	return (*p)(crn, state_ptr);
}

int cc_Close(LINEDEV linedev)
{
	ptr_cc_Close p;

	p = (ptr_cc_Close)*CCFunc[cc_Close_ID].fptr;
	return (*p)(linedev);
}

int cc_Congestion(CRN crn, int cause)
{
	ptr_cc_Congestion p;

	p = (ptr_cc_Congestion)*CCFunc[cc_Congestion_ID].fptr;
	return (*p)(crn, cause);
}

int cc_DropCall(CRN crn, int cause, unsigned long mode)
{
	ptr_cc_DropCall p;

	p = (ptr_cc_DropCall)*CCFunc[cc_DropCall_ID].fptr;
	return (*p)(crn, cause, mode);
}

int cc_FacilityAck(CRN crn, NFACILITY_ELEM *facility_ptr)
{
	ptr_cc_FacilityAck p;

	p = (ptr_cc_FacilityAck)*CCFunc[cc_FacilityAck_ID].fptr;
	return (*p)(crn, facility_ptr);
}

int cc_FacilityRej(CRN crn, NFACILITY_ELEM *facility_ptr, int cause)
{
	ptr_cc_FacilityRej p;

	p = (ptr_cc_FacilityRej)*CCFunc[cc_FacilityRej_ID].fptr;
	return (*p)(crn, facility_ptr, cause);
}

int cc_FacilityReq(CRN crn, NFACILITY_ELEM *facility_buf, unsigned long mode)
{
	ptr_cc_FacilityReq p;

	p = (ptr_cc_FacilityReq)*CCFunc[cc_FacilityReq_ID].fptr;
	return (*p)(crn, facility_buf, mode);
}

int cc_GetANI(CRN crn, char * anibuf)
{
	ptr_cc_GetANI p;

	p = (ptr_cc_GetANI)*CCFunc[cc_GetANI_ID].fptr;
	return (*p)(crn, anibuf);
}

int cc_GetBilling(CRN crn, char *billing_buf)
{
	ptr_cc_GetBilling p;

	p = (ptr_cc_GetBilling)*CCFunc[cc_GetBilling_ID].fptr;
	return (*p)(crn, billing_buf);
}

int cc_GetCallInfo(CRN crn, int info_id, char *valuep)
{
	ptr_cc_GetCallInfo p;

	p = (ptr_cc_GetCallInfo)*CCFunc[cc_GetCallInfo_ID].fptr;
	return (*p)(crn, info_id, valuep);
}

int cc_GetInfoElem(LINEDEV ddd, IE_BLK *iep)
{
	ptr_cc_GetInfoElem p;

	p = (ptr_cc_GetInfoElem)*CCFunc[cc_GetInfoElem_ID].fptr;
	return  (*p)(ddd, iep);
}

int cc_GetCRN(CRN *crn_ptr, void * evtdatap)
{
	ptr_cc_GetCRN p;

	p = (ptr_cc_GetCRN)*CCFunc[cc_GetCRN_ID].fptr;
	return (*p)(crn_ptr, evtdatap);
}

int cc_GetDNIS(CRN crn, char *dnis)
{
	ptr_cc_GetDNIS p;

	p = (ptr_cc_GetDNIS)*CCFunc[cc_GetDNIS_ID].fptr;
	return (*p)(crn, dnis);
}

int cc_GetEvtMsk(LINEDEV devhdl, unsigned long *maskp)
{
	ptr_cc_GetEvtMsk p;

	p = (ptr_cc_GetEvtMsk)*CCFunc[cc_GetEvtMsk_ID].fptr;
	return (*p)(devhdl, maskp);
}

int cc_GetVoiceH(LINEDEV linedev, int * voiceh)
{
	ptr_cc_GetVoiceH p;

	p = (ptr_cc_GetVoiceH)*CCFunc[cc_GetVoiceH_ID].fptr;
	return (*p)(linedev, voiceh);
}

int cc_GetNetH(LINEDEV linedev, int * neth)
{
	ptr_cc_GetNetH p;

	p = (ptr_cc_GetNetH)*CCFunc[cc_GetNetH_ID].fptr;
	return (*p)(linedev, neth);
}

int cc_GetParm(LINEDEV linedev, int parm_id, CC_PARM *value_ptr)
{
	ptr_cc_GetParm p;

	p = (ptr_cc_GetParm)*CCFunc[cc_GetParm_ID].fptr;
	return (*p)(linedev, parm_id, value_ptr);
}

int cc_GetUsrAttr(LINEDEV linedev, long *usr_attrp)
{
	ptr_cc_GetUsrAttr p;

	p = (ptr_cc_GetUsrAttr)*CCFunc[cc_GetUsrAttr_ID].fptr;
	return (*p)(linedev, usr_attrp);
}

int cc_GetVer(LINEDEV linedev, unsigned int * major_ptr, unsigned int *minor_ptr)
{
	ptr_cc_GetVer p;

	p = (ptr_cc_GetVer)*CCFunc[cc_GetVer_ID].fptr;
	return (*p)(linedev, major_ptr, minor_ptr);
}

int cc_GetLineDev(LINEDEV *linedev_ptr, void * evtdata_ptr)
{
	ptr_cc_GetLineDev p;

	p = (ptr_cc_GetLineDev)*CCFunc[cc_GetLineDev_ID].fptr;
	return (*p)(linedev_ptr, evtdata_ptr);
}

int cc_MakeCall(LINEDEV linedev, CRN *crn_buf, char *phone_num,
		MAKECALL_BLK *makecall_blkp, int timeout, unsigned long mode)
{
	ptr_cc_MakeCall p;

	p = (ptr_cc_MakeCall)*CCFunc[cc_MakeCall_ID].fptr;
	return (*p)(linedev, crn_buf, phone_num, makecall_blkp, timeout, mode);
}

int cc_Open(LINEDEV *linedevbuf, char *dev_name, unsigned short rfu)
{
	ptr_cc_Open p;

	p = (ptr_cc_Open)*CCFunc[cc_Open_ID].fptr;
	return (*p)(linedevbuf, dev_name, rfu);
}

int cc_ReleaseCall(CRN crn)
{
	ptr_cc_ReleaseCall p;

	p = (ptr_cc_ReleaseCall)*CCFunc[cc_ReleaseCall_ID].fptr;
	return (*p)(crn);
}

int cc_ReqANI(CRN crn, char *anibuf, int req_type, unsigned long mode)
{
	ptr_cc_ReqANI p;

	p = (ptr_cc_ReqANI)*CCFunc[cc_ReqANI_ID].fptr;
	return (*p)(crn, anibuf, req_type, mode);
}

int cc_ResultValue(void * evtdata_ptr)
{
	ptr_cc_ResultValue p;

	p = (ptr_cc_ResultValue)*CCFunc[cc_ResultValue_ID].fptr;
	return (*p)(evtdata_ptr);
}

int cc_ResultMsg(LINEDEV linedev, int ResultCode, char **msg)
{
	ptr_cc_ResultMsg p;

	p = (ptr_cc_ResultMsg)*CCFunc[cc_ResultMsg_ID].fptr;
	return (*p)(linedev, ResultCode, msg);
}

int cc_SetBilling(CRN crn, int rate_type, CC_RATE_U *ratep, unsigned long mode)
{
	ptr_cc_SetBilling p;

	p = (ptr_cc_SetBilling)*CCFunc[cc_SetBilling_ID].fptr;
	return (*p)(crn, rate_type, ratep, mode);
}

int cc_SetCallingNum(LINEDEV linedev, char *callingnum)
{
	ptr_cc_SetCallingNum p;

	p = (ptr_cc_SetCallingNum)*CCFunc[cc_SetCallingNum_ID].fptr;
	return (*p)(linedev, callingnum);
}

int cc_SetChanState(LINEDEV linedev, int chan_state, unsigned long mode)
{
	ptr_cc_SetChanState p;

	p = (ptr_cc_SetChanState)*CCFunc[cc_SetChanState_ID].fptr;
	return (*p)(linedev, chan_state, mode);
}

int cc_SetEvtMsk(LINEDEV devhdl, unsigned long mask, int action)
{
	ptr_cc_SetEvtMsk p;

	p = (ptr_cc_SetEvtMsk)*CCFunc[cc_SetEvtMsk_ID].fptr;
	return (*p)(devhdl, mask, action);
}

int cc_SetInfoElem(LINEDEV linedev, IE_BLK *ie_ptr)
{
	ptr_cc_SetInfoElem p;

	p = (ptr_cc_SetInfoElem)*CCFunc[cc_SetInfoElem_ID].fptr;
	return (*p)(linedev, ie_ptr);
}

int cc_SetParm(LINEDEV linedev, int parm_id, long value)
{
	ptr_cc_SetParm p;

	p = (ptr_cc_SetParm)*CCFunc[cc_SetParm_ID].fptr;
	return (*p)(linedev, parm_id, value);
}

int cc_SetUsrAttr(LINEDEV linedev, long usr_attr)
{
	ptr_cc_SetUsrAttr p;

	p = (ptr_cc_SetUsrAttr)*CCFunc[cc_SetUsrAttr_ID].fptr;
	return (*p)(linedev, usr_attr);
}

int cc_StartTrace(LINEDEV linedev, char *tracefilename)
{
	ptr_cc_StartTrace p;

	p = (ptr_cc_StartTrace)*CCFunc[cc_StartTrace_ID].fptr;
	return (*p)(linedev, tracefilename);
}

int cc_StopTrace(LINEDEV linedev)
{
	ptr_cc_StopTrace p;

	p = (ptr_cc_StopTrace)*CCFunc[cc_StopTrace_ID].fptr;
	return (*p)(linedev);
}

int cc_WaitCall(LINEDEV linedev, CRN *crnptr, WAITCALL_BLK *waitcall_blkp,
		int timeout, unsigned long mode)    
{
	ptr_cc_WaitCall p;

	p = (ptr_cc_WaitCall)*CCFunc[cc_WaitCall_ID].fptr;
	return (*p)(linedev, crnptr, waitcall_blkp, timeout, mode);
}


int cc_CauseValue(LINEDEV linedev)
{
	ptr_cc_CauseValue p;

	p = (ptr_cc_CauseValue)*CCFunc[cc_CauseValue_ID].fptr;
	return (*p)(linedev);
}

int cc_Restart(LINEDEV linedev, unsigned long mode)
{
	ptr_cc_Restart p;

	p = (ptr_cc_Restart)*CCFunc[cc_Restart_ID].fptr;
	return (*p)(linedev, mode);
}

int cc_GetMoreDigits(CRN crn, int num_digits, long timeout, unsigned long mode)
{
	ptr_cc_GetMoreDigits p;

	p = (ptr_cc_GetMoreDigits)*CCFunc[cc_GetMoreDigits_ID].fptr;
	return (*p)(crn, num_digits, timeout, mode);
}

int cc_SetMinDigits(LINEDEV linedev, int mindigs)
{
	ptr_cc_SetMinDigits p;

	p = (ptr_cc_SetMinDigits)*CCFunc[cc_SetMinDigits_ID].fptr;
	return (*p)(linedev, mindigs);
}

int cc_SndMsg( CRN crn, int msg_type, IE_BLK *sndmsgptr )
{
	ptr_cc_SndMsg p;

	p = (ptr_cc_SndMsg)*CCFunc[cc_SndMsg_ID].fptr;
	return (*p)(crn, msg_type, sndmsgptr);
}

int cc_GetBChanState(LINEDEV ddd, int *l2stateptr )
{
	ptr_cc_GetBChanState p;

	p = (ptr_cc_GetBChanState)*CCFunc[cc_GetBChanState_ID].fptr;
	return (*p)(ddd, l2stateptr);
}

int cc_GetDChanState(LINEDEV ddd, int *l2stateptr )
{
	ptr_cc_GetDChanState p;

	p = (ptr_cc_GetDChanState)*CCFunc[cc_GetDChanState_ID].fptr;
	return (*p)(ddd, l2stateptr);
}

int cc_CallAck(CRN crn, LINEDEV new_linedev, int msg_id)
{
	ptr_cc_CallAck p;

	p = (ptr_cc_CallAck)*CCFunc[cc_CallAck_ID].fptr;
	return (*p)(crn, new_linedev, msg_id);
}
int cc_SndFrame(LINEDEV devhdl, IE_BLK *sndframptr)
{
	ptr_cc_SndFrame p;

	p = (ptr_cc_SndFrame)*CCFunc[cc_SndFrame_ID].fptr;
	return (*p)(devhdl, sndframptr);
}
int cc_GetFrame(LINEDEV devhdl, L2_BLK *rcvframptr)
{
	ptr_cc_GetFrame p;

	p = (ptr_cc_GetFrame)*CCFunc[cc_GetFrame_ID].fptr;
	return (*p)(devhdl, rcvframptr);
}
int cc_HoldAck(CRN crn)
{
	ptr_cc_HoldAck p;

	p = (ptr_cc_HoldAck)*CCFunc[cc_HoldAck_ID].fptr;
	return (*p)(crn);
}
int cc_HoldCall(CRN crn, unsigned long mode)
{
	ptr_cc_HoldCall p;

	p = (ptr_cc_HoldCall)*CCFunc[cc_HoldCall_ID].fptr;
	return (*p)(crn, mode);
}
int cc_HoldRej(CRN crn, int cause)
{
	ptr_cc_HoldRej p;

	p = (ptr_cc_HoldRej)*CCFunc[cc_HoldRej_ID].fptr;
	return (*p)(crn, cause);
}
int cc_RetrieveAck(CRN crn)
{
	ptr_cc_RetrieveAck p;

	p = (ptr_cc_RetrieveAck)*CCFunc[cc_RetrieveAck_ID].fptr;
	return (*p)(crn);
}
int cc_RetrieveCall(CRN crn, unsigned long mode)
{
	ptr_cc_RetrieveCall p;

	p = (ptr_cc_RetrieveCall)*CCFunc[cc_RetrieveCall_ID].fptr;
	return (*p)(crn, mode);
}
int cc_RetrieveRej(CRN crn, int cause)
{
	ptr_cc_RetrieveRej p;

	p = (ptr_cc_RetrieveRej)*CCFunc[cc_RetrieveRej_ID].fptr;
	return (*p)(crn, cause);
}
int cc_TransferCall(CRN crn1, CRN crn2, unsigned long mode)
{
	ptr_cc_TransferCall p;

	p = (ptr_cc_TransferCall)*CCFunc[cc_TransferCall_ID].fptr;
	return (*p)(crn1, crn2, mode);
}
int cc_TransferAck(CRN crn1)
{
	ptr_cc_TransferAck p;

	p = (ptr_cc_TransferAck)*CCFunc[cc_TransferAck_ID].fptr;
	return (*p)(crn1);
}
int cc_TransferRej(CRN crn1, INT nCause)
{
	ptr_cc_TransferRej p;

	p = (ptr_cc_TransferRej)*CCFunc[cc_TransferRej_ID].fptr;
	return (*p)(crn1, nCause);
}

int cc_BlockTs(LINEDEV ddd)
{
	ptr_cc_BlockTs p;

	p = (ptr_cc_BlockTs)*CCFunc[cc_BlockTs_ID].fptr;
	return  (*p)(ddd);
}
int cc_PutEvt(LINEDEV ddd, long event_type)
{
	ptr_cc_PutEvt p;

	p = (ptr_cc_PutEvt)*CCFunc[cc_PutEvt_ID].fptr;
	return  (*p)(ddd, event_type);
}
int cc_RejectCall(CRN crn, int cause, unsigned long mode)
{
	ptr_cc_RejectCall p;

	p = (ptr_cc_RejectCall)*CCFunc[cc_RejectCall_ID].fptr;
	return (*p)(crn, cause, mode);
}
int cc_UnBlockTs(LINEDEV ddd)
{
	ptr_cc_UnBlockTs p;

	p = (ptr_cc_UnBlockTs)*CCFunc[cc_UnBlockTs_ID].fptr;
	return  (*p)(ddd);
}
int cc_geterror(void)
{
	ptr_cc_geterror p;

	p = (ptr_cc_geterror)*CCFunc[cc_geterror_ID].fptr;
	return (*p)();
}
int cc_seterror(int error)
{
	ptr_cc_seterror p;

	p = (ptr_cc_seterror)*CCFunc[cc_seterror_ID].fptr;
	return (*p)(error);
}
int is_GetAllCRN( LINEDEV handle, int *num_crn, CRN *crnptr )
{
	ptr_is_GetAllCRN p;

	p = (ptr_is_GetAllCRN)*CCFunc[is_GetAllCRN_ID].fptr;
	return  (*p)(handle, num_crn, crnptr);
}
int is_internaltest( CRN crn,  int msgid, int length, char *backdata )
{
	ptr_is_internaltest p;

	p = (ptr_is_internaltest)*CCFunc[is_internaltest_ID].fptr;
	return (*p)(crn, msgid, length, backdata);
}
int cc_GetSigInfo(CHAR *lpValue,INT nInfoID,LPVOID lpVoid)
{
	ptr_cc_GetSigInfo p;

	p = (ptr_cc_GetSigInfo)*CCFunc[cc_GetSigInfo_ID].fptr;
	return (*p)(lpValue, nInfoID, lpVoid);
}

int cc_GetNetCRV(CRN crn, int *netcrvp)
{
	ptr_cc_GetNetCRV p;

	p = (ptr_cc_GetNetCRV)*CCFunc[cc_GetNetCRV_ID].fptr;
	return (*p)(crn, netcrvp);
}

int cc_SetDChanCfg( LINEDEV linedev, DCHAN_CFG *dchan_cfg_ptr )
{
	ptr_cc_SetDChanCfg p;

	p = (ptr_cc_SetDChanCfg)*CCFunc[cc_SetDChanCfg_ID].fptr;
	return (*p)(linedev,dchan_cfg_ptr);
}
int cc_TermRegisterResponse( LINEDEV linedev, TERM_BLK *term_blk_ptr )
{
	ptr_cc_TermRegisterResponse p;

	p = (ptr_cc_TermRegisterResponse)*CCFunc[cc_TermRegisterResponse_ID].fptr;
	return (*p)(linedev,term_blk_ptr);
}

int cc_GetDLinkState( LINEDEV linedev, DLINK *dlinkptr, int *state_buf )
{
	ptr_cc_GetDLinkState p;

	p = (ptr_cc_GetDLinkState)*CCFunc[cc_GetDLinkState_ID].fptr;
	return (*p)(linedev,dlinkptr,state_buf);
}

int cc_GetCES(CHAR *lpValue,LPVOID lpVoid)
{
   ptr_cc_GetCES p;

	p = (ptr_cc_GetCES)*CCFunc[cc_GetCES_ID].fptr;
	return (*p)(lpValue, lpVoid);
}

int cc_GetSAPI (CHAR *lpValue,LPVOID lpVoid)
{
	ptr_cc_GetSAPI p;

	p = (ptr_cc_GetSAPI)*CCFunc[cc_GetSAPI_ID].fptr;
	return (*p)(lpValue, lpVoid);
}


int cc_SndNonCallMsg( LINEDEV linedev, int crn_type, int msg_type, NONCRN_BLK *noncallmsgptr )
{
	ptr_cc_SndNonCallMsg p;

	p = (ptr_cc_SndNonCallMsg)*CCFunc[cc_SndNonCallMsg_ID].fptr;
	return (*p)(linedev, crn_type, msg_type, noncallmsgptr);
}

int cc_GetNonCallMsg( LINEDEV linedev, NONCRN_BLK *noncallmsgptr )
{
	ptr_cc_GetNonCallMsg p;

	p = (ptr_cc_GetNonCallMsg)*CCFunc[cc_GetNonCallMsg_ID].fptr;
	return (*p)(linedev, noncallmsgptr);
}


int cc_SetParmEx(LINEDEV linedev, int parm_id, PARM_INFO *value_ptr)
{
	ptr_cc_SetParmEx p;

	p = (ptr_cc_SetParmEx)*CCFunc[cc_SetParmEx_ID].fptr;
	return (*p)(linedev, parm_id, value_ptr);
}

int cc_GetParmEx(LINEDEV linedev, int parm_id, PARM_INFO *value_ptr)
{
	ptr_cc_GetParmEx p;

	p = (ptr_cc_GetParmEx)*CCFunc[cc_GetParmEx_ID].fptr;
	return (*p)(linedev, parm_id, value_ptr);
}

int cc_ToneRedefine(LINEDEV LineDev, unsigned char sigtype, toneParm *pToneParm, MODE Mode)
{
	ptr_cc_ToneRedefine p;

	p = (ptr_cc_ToneRedefine)*CCFunc[cc_ToneRedefine_ID].fptr;
	return (*p)(LineDev,sigtype,pToneParm,Mode);
}

int cc_PlayTone(LINEDEV LineDev, toneParm *pToneParm, DV_TPT *tptp, MODE Mode)
{
	ptr_cc_PlayTone p;

	p = (ptr_cc_PlayTone)*CCFunc[cc_PlayTone_ID].fptr;
	return (*p)(LineDev,pToneParm,tptp, Mode);
}

int cc_StopTone(LINEDEV LineDev, MODE Mode)
{
	ptr_cc_StopTone p;

	p = (ptr_cc_StopTone)*CCFunc[cc_StopTone_ID].fptr;
	return (*p)(LineDev,Mode);
}

int cc_ReleaseCallEx(CRN crn, MODE nMode)
{
 	ptr_cc_ReleaseCallEx p;
 
 	p = (ptr_cc_ReleaseCallEx)*CCFunc[cc_ReleaseCallEx_ID].fptr;
 	return (*p)(crn,nMode);
}
 
int cc_int_LINEDEV_notimp(LINEDEV linedev)
{
	dt_set_lasterr(linedev, EDT_INVMSG);
	return -1;
}

int cc_int_CRN_notimp(CRN crn)
{
	LINEDEV linedev;

	cc_CRN2LineDev(crn, &linedev);
	cc_int_LINEDEV_notimp(linedev);
	return -1;
}

int cc_int_notimp(void)
{
	return -1;
}

int cc_SetDLinkState( LINEDEV linedev, DLINK *dlinkptr, int *state_buf )
{
	ptr_cc_SetDLinkState p;

	p = (ptr_cc_SetDLinkState)*CCFunc[cc_SetDLinkState_ID].fptr;
	return (*p)(linedev,dlinkptr,state_buf);
}

int cc_SetDLinkCfg( LINEDEV linedev, DLINK *dlinkptr, DLINK_CFG *config)
{
	ptr_cc_SetDLinkCfg p;

	p = (ptr_cc_SetDLinkCfg)*CCFunc[cc_SetDLinkCfg_ID].fptr;
	return (*p)(linedev,dlinkptr,config);
}

int cc_GetDLinkCfg( LINEDEV linedev, DLINK *dlinkptr, DLINK_CFG *config)
{
	ptr_cc_GetDLinkCfg p;

	p = (ptr_cc_GetDLinkCfg)*CCFunc[cc_GetDLinkCfg_ID].fptr;
	return (*p)(linedev,dlinkptr,config);
}

int cc_Register( LINEDEV linedev, CRN * crn_buf, NONCALL_BLK *noncall_blkp, unsigned int mode )
{
	ptr_cc_Register p;

 	p = (ptr_cc_Register)*CCFunc[cc_Register_ID].fptr;
	return (*p)(linedev, crn_buf, noncall_blkp, mode);
}
