/***************************************************************

	%name:           sherr.h %
	%created_by:     fourniea %
	%date_created:   %

	Description:		
	Include file that contains the error code definitions of the
	Switch Handler library.

	%version:        %
	%derived_by:     % 
	%date_modified:  %

	(c) 1998, Dialogic Corporation.  All rights reserved.

***************************************************************/

#ifndef __sherr_h__
#define __sherr_h__

/*
 *	SH library return status codes.
 */

#define SH_RET_OK               0	/* Successful return. */
#define SH_SHLIB_BUSY           1	/* SH library is busy processing another request. */
#define SH_BAD_SHINDX           2	/* Invalid SH index number. */
#define SH_SHLIB_NOT_INIT       3	/* SH library has not been initialized via sh_setloc(). */
#define SH_NO_CLOCK             4	/* Clock fallback failed. */
#define SH_MAX_SH_EXCEED        5 	/* Number of SH out of range. */
#define SH_NO_SH_PRESENT        6	/* SH is not present. */
#define SH_INIT_FAIL            7 	/* Can not initialize SH hardware. */
#define SH_BAD_PARMID           8	/* Invalid parameter id. */
#define SH_BAD_PARMVAL          9	/* Invalid value for parameter id. */
#define SH_BAD_MODE            10	/* Invalid bus mode. */
#define SH_BAD_CLKSRC          11	/* Invalid clock mode. */
#define SH_BAD_CLKSPD          12	/* Invalid clock speed. */
#define SH_BAD_BUSSPD          13	/* Invalid bus speed. */
#define SH_NO_SCLKX2_N         14	/* Clock speed not greater than bus speed in SCbus mode. */
#define SH_BAD_LOCTS           15	/* Invalid local timeslot parameter. */
#define SH_BAD_TYPE            16	/* Invalid type. */
#define SH_BAD_EXTTS           17	/* External timeslot not supported at current clock rate. */
#define SH_LOCTS_SET           18	/* Local timeslot already connected. */
#define SH_LOCTS_DISCONNECT    19	/* Local timeslot disconnected. */
#define SH_NOT_PEB_RM          20	/* Not PEB resource module. */
#define SH_NO_CONNECT          21	/* No connection established in PEB switching mode. */
#define SH_NO_CLK_SRC          22	/* Clock source is not available or invalid. */
#define SH_PREV_SLCTED         23	/* Module already selected as the secondary clock source. */
#define SH_NOT_PS_SRC          24	/* Module is currently not a primary or secondary clock source module. */
#define SH_NO_CLKINT_PEND      25	/* No clock fail interrupt pending. */
#define SH_NOT_PEB_MODE        26	/* Not operating in a PEB configuration */
#define SH_NOT_SWITCH          27	/* Not operating in SCbus or PEB switching mode */
#define SH_NOT_SCBUS           28	/* Not operating in SCbus mode */
#define SH_NOT_SECOND_SRC      29	/* Not secondary clock source */
#define SH_UNSUPPORTED         30   /* SH hardware not supported by SH library */
#define SH_NOT_NETWK_MODE      31   /* Not operating in PEB network mode. */
#define SH_INVALID_NUMSH       32   /* Invalid number of SH. */
#define SH_NOT_PS_RSC          33	/* Module is currently not a primary or secondary clock source module. */
#endif /* __sherr_h__ */
