//
//  Copyright (c) 1999-2006 by AudioCodes USA, Inc.
//  All rights reserved.
//
//  File: NTiDataDCC.h
//      SmartTAP D-Channel API data structure declaration file
//
//  AUDIOCODES USA, INC. PROPRIETARY.
//


#ifndef _INC_NTIDATADCC_H
#define _INC_NTIDATADCC_H


//PBX Manufacturer Codes (sorted numerically)

#define PBX_NORTEL                      0x01
#define PBX_LUCENT                      0x02
#define PBX_NEC                         0x03
#define PBX_ERICSSON                    0x04
#define PBX_SIEMENS                     0x05
#define PBX_ASPECT                      0x06
#define PBX_ALCATEL                     0x07
#define PBX_BOSCH                       0x08
#define PBX_COMDIAL                     0x09
#define PBX_INTECOM                     0x0A
#define PBX_INTERTEL                    0x0B
#define PBX_NITSUKO                     0x0C
#define PBX_TELRAD                      0x0D
#define PBX_IWATSU                      0x0E
#define PBX_PANASONIC                   0x0F
#define PBX_MITEL                       0x10
#define PBX_BRI                         0x11
#define PBX_SAMSUNG                     0x12
#define PBX_PHILIPS                     0x13
#define PBX_FUJITSU                     0x14
#define PBX_ROCKWELL                    0x15
#define PBX_TOSHIBA                     0x16
#define PBX_LG                          0x17
#define PBX_EON                         0x18
#define PBX_TADIRAN                     0x19
#define PBX_TELTRONICS					0x1A
#define PBX_AASTRA						0x1B
#define PBX_ESI							0x1D
#define PBX_POLYCOM						0x1E


//PBX Model Codes (sorted alphabetically by PBX vendor then numerically)

#define PBX_AASTRA_INTELLIGATE			0x01

#define PBX_TELTRONICS_HARRIS2020		0x01

#define PBX_ALCATEL_4200_4400           0x01
#define PBX_ALCATEL_4095                0x03

#define PBX_ASPECT_ACD                  0x01

#define PBX_BOSCH_INTEGRAL_2W           0x01
#define PBX_BOSCH_INTEGRAL_4W           0x02
#define PBX_BOSCH_INTEGRAL_5            PBX_BOSCH_INTEGRAL_2W
#define PBX_BOSCH_INTEGRAL_3            PBX_BOSCH_INTEGRAL_33
#define PBX_BOSCH_INTEGRAL_55           0x03
#define PBX_BOSCH_INTEGRAL_33           0x04

#define PBX_BRI_ISDN                    0x01
#define PBX_BRI_ISDN_NI1                0x02
#define PBXBRI                  ((PBX_BRI << 8) | PBX_BRI_ISDN)

#define PBX_COMDIAL_IMPACTSCS           0x01

#define PBX_EON_EQ                      0x01

#define PBX_ERICSSON_MD110              0x01
#define PBX_ERICSSON_MD110_ELU_25       0x01
#define PBX_ERICSSON_MD110_ELU_5        0x02
#define PBX_ERICSSON_BP50_ELU_D3        0x03

#define PBX_FUJITSU_F9600               0x01

#define PBX_INTECOM_E2W                 0x01
#define PBX_INTECOM_E4W                 0x02

#define PBX_INTERTEL_AXXESS             0x01

#define PBX_LG_STAREX_CS                0x01
#define PBX_LG_LDK50	                0x02

#define PBX_LUCENT_DEFINITY2W           0x01
#define PBX_LUCENT_DEFINITY4W           0x02
#define PBX_LUCENT_MERLIN_MAGIX         0x03
#define PBX_LUCENT_INDEX                0x04
#define PBX_LUCENT_MLX4W                0x05
#define PBX_LUCENT_CONSOLE302           0x06

#define PBX_MITEL_SX2000                0x01

#define PBX_NEC_ELECTRA_ELITE_192       0x01
#define PBX_NEC_NEAX_1000               0x02
#define PBX_NEC_NEAX_2000               0x03
#define PBX_NEC_NEAX_2400               0x04
#define PBX_NEC_NEAX_PROFESSIONAL       0x05

#define PBX_NITSUKO_I                   0x01

#define PBX_NORTEL_MERIDIAN             0x01
#define PBX_NORTEL_NORSTAR              0x02
#define PBX_NORTEL_MATRA                0x03
#define PBX_NORTEL_MERIDIAN_CONSOLE     0x04

#define PBX_PANASONIC_KX_TDA            0x01
#define PBX_PANASONIC_7600_SPECIAL      0x02

#define PBX_PHILIPS_IS3000_2W           0x01
#define PBX_PHILIPS_IS3000_4W           0x02
#define PBX_PHILIPS_IS3000_4W_TMP       0x03

#define PBX_ROCKWELL_SPECTRUM           0x01

#define PBX_SAMSUNG_DCS_828             0x01
#define PBX_SAMSUNG_INFOREX             0x02

#define PBX_SIEMENS_HICOM_HIPATH        0x01
#define PBX_SIEMENS_ROLM                0x02
#define PBX_SIEMENS_DTI_4W              0x03
#define PBX_SIEMENS_ISDT_2W             0x04

#define PBX_TADIRAN_CORAL               0x01

#define PBX_TELRAD_IS2W                 0x01

#define PBX_TOSHIBA_STRATA              0x01
#define PBX_TOSHIBA_STRATA_DK           0x01
#define PBX_TOSHIBA_STRATA_CTX          0x01

#define PBX_ESI_100						0x01

#define PBX_POLYCOM_550D				0x01

//End PBX Model Codes

#define MAX_DAC_BUFFER                  1024
#define MAX_MSG_BUFFER                  512
#define BIGBUFFERLEN                    2880

#define GREENLIGHT                      8
#define REDLIGHT                        9
#define AMBERLIGHT                      10

#define ALCATEL_RIGHT_SQUARE            8
#define ALCATEL_MUSIC_SYMBOL            9
#define ALCATEL_CENTER_SQUARE           10
#define ALCATEL_HANDSET_SYMBOL          11
#define ALCATEL_LEFT_SQUARE             12
#define ALCATEL_ALERT_SYMBOL            13

/*---------------------------------------------------------------------------
 * Cisco SCCP (Skinny) Call Information Message 
 *--------------------------------------------------------------------------*/

#define MT_CISCO_SCCP_MAX_NAME_SIZE          40
#define MT_CISCO_SCCP_MAX_DIRECTORY_NUM_SIZE 24

// Cisco SCCP Call Types
#define MT_CISCO_SCCP_CALL_TYPE_INBOUND      1
#define MT_CISCO_SCCP_CALL_TYPE_OUTBOUND     2
#define MT_CISCO_SCCP_CALL_TYPE_FORWARD      3

typedef struct
{
  UCHAR   CallingPartyName[MT_CISCO_SCCP_MAX_NAME_SIZE];
  UCHAR   CallingParty[MT_CISCO_SCCP_MAX_DIRECTORY_NUM_SIZE];
  UCHAR   CalledPartyName[MT_CISCO_SCCP_MAX_NAME_SIZE];
  UCHAR   CalledParty[MT_CISCO_SCCP_MAX_DIRECTORY_NUM_SIZE];
  ULONG   LineInstance;
  ULONG   CallId;
  ULONG   CallType;
  UCHAR   OrigCalledPartyName[MT_CISCO_SCCP_MAX_NAME_SIZE];
  UCHAR   OrigCalledParty[MT_CISCO_SCCP_MAX_DIRECTORY_NUM_SIZE];
  UCHAR   LastRedirectingPartyName[MT_CISCO_SCCP_MAX_NAME_SIZE];
  UCHAR   LastRedirectingParty[MT_CISCO_SCCP_MAX_DIRECTORY_NUM_SIZE];
  ULONG   OrigCalledPartyRedirectReason;
  ULONG   LastRedirectReason;
  UCHAR   CallingPartyVoiceMailbox[MT_CISCO_SCCP_MAX_DIRECTORY_NUM_SIZE]; 
  UCHAR   CalledPartyVoiceMailbox[MT_CISCO_SCCP_MAX_DIRECTORY_NUM_SIZE];
  UCHAR   OriginalCalledPartyVoiceMailbox[MT_CISCO_SCCP_MAX_DIRECTORY_NUM_SIZE];
  UCHAR   LastRedirectVoiceMailbox[MT_CISCO_SCCP_MAX_DIRECTORY_NUM_SIZE];
  ULONG CallInstance;
  ULONG CallSecurityStatus;
  ULONG PartyPIRestrictionBits;

}MT_CISCO_SCCP_CALL_INFO, *PMT_CISCO_SCCP_CALL_INFO;

typedef struct
{
   ULONG Year;
   ULONG Month;
   ULONG DayOfWeek;
   ULONG Day;
   ULONG Hour;
   ULONG Min;
   ULONG Sec;
   ULONG mSec;
} MT_TIME_AND_DATE, *PMT_TIME_AND_DATE;

//
// IP Media Session QoS Report
//
typedef struct
{
  ULONG  SessionID;                        // Session ID
  USHORT PrimaryStationRxJitter_Average;
  USHORT PrimaryStationRxJitter_Peak;
  USHORT SecondaryStationRxJitter_Average;
  USHORT SecondaryStationRxJitter_Peak;
  ULONG  PrimaryStationRtpTotalPktCnt;
  ULONG  SecondaryStationRtpTotalPktCnt;
} MT_IP_SESSION_QOS_REPORT, *PMT_IP_SESSION_QOS_REPORT;

#endif
// End of NTiDataDCC.h
