//
//  Copyright (c) 1999-2007 by AudioCodes USA, Inc.
//  All rights reserved.
//
//  NTiEvent.h
//      SmartWORKS API event definition file
//
//  AUDIOCODES USA, INC. PROPRIETARY.
//

#ifndef _INC_NTIEVENTDCC_H
#define _INC_NTIEVENTDCC_H


// NGX D-Channel specific events

// Light events are aliased with Function Light events to remain
// backwards compatible

#define EVT_LIGHT_ON                            0x1001
#define EVT_FUNCTION_LIGHT_ON                   EVT_LIGHT_ON
#define EVT_LIGHT_OFF                           0x1002
#define EVT_FUNCTION_LIGHT_OFF                  EVT_LIGHT_OFF
#define EVT_LIGHT_FLASHING                      0x1003
#define EVT_FUNCTION_LIGHT_FLASHING             EVT_LIGHT_FLASHING

#define EVT_DIGIT_PRESSED                       0x1006
#define EVT_DIGIT_RELEASED                      0x1007
#define EVT_MESSAGE_CHANGE                      0x1008
#define EVT_STARTSTOP_ON                        0x1009
#define EVT_STARTSTOP_OFF                       0x100a
#define EVT_LIGHT_FASTFLASHING                  0x100b
#define EVT_FUNCTION_LIGHT_FASTFLASHING         EVT_LIGHT_FASTFLASHING
#define EVT_DOWNLOAD_STATUS                     0x100c
#define EVT_FINISHED_PLAY                       0x100d
#define EVT_FUNCTION_BUTTON_PRESSED             0x100e
#define EVT_FUNCTION_BUTTON_RELEASED            0x100f
#define EVT_HOLD_BUTTON_PRESSED                 0x1010
#define EVT_HOLD_BUTTON_RELEASED                0x1011
#define EVT_RELEASE_BUTTON_PRESSED              0x1012
#define EVT_RELEASE_BUTTON_RELEASED             0x1013
#define EVT_TRANSFER_BUTTON_PRESSED             0x1014
#define EVT_ANSWER_BUTTON_PRESSED               0x1015
#define EVT_SPEAKER_BUTTON_PRESSED              0x1016
#define EVT_REDIAL_BUTTON_PRESSED               0x1017
#define EVT_CONF_BUTTON_PRESSED                 0x1018
#define EVT_CONFERENCE_BUTTON_PRESSED           EVT_CONF_BUTTON_PRESSED
#define EVT_RECALL_BUTTON_PRESSED               0x1019
#define EVT_FEATURE_BUTTON_PRESSED              0x101a
#define EVT_UP_DOWN                             0x101b
#define EVT_EXIT_BUTTON_PRESSED                 0x101c
#define EVT_HELP_BUTTON_PRESSED                 0x101d
#define EVT_SOFT_BUTTON_PRESSED                 0x101e
#define EVT_RING_ON                             0x101f
#define EVT_RING_OFF                            0x1020
#define EVT_LINE_BUTTON_PRESSED                 0x1021
#define EVT_MENU_BUTTON_PRESSED                 0x1022
#define EVT_PREVIOUS_BUTTON_PRESSED             0x1023
#define EVT_NEXT_BUTTON_PRESSED                 0x1024
#define EVT_LIGHT_QUICKFLASH                    0x1025
#define EVT_FUNCTION_LIGHT_QUICKFLASH           EVT_LIGHT_QUICKFLASH
#define EVT_AUDIO_ON                            0x1026
#define EVT_AUDIO_OFF                           0x1027
#define EVT_DISPLAY_CLOCK                       0x1028
#define EVT_DISPLAY_TIMER                       0x1029
#define EVT_DISPLAY_CLEAR                       0x102a
#define EVT_CFWD                                0x102b
#define EVT_CFWD_CANCELED                       0x102c
#define EVT_AUTO_ANSWER                         0x102d
#define EVT_AUTO_ANSWER_CANCELED                0x102e
#define EVT_SET_BUSY                            0x102f
#define EVT_SET_BUSY_CANCELED                   0x1030
#define EVT_DESTINATION_BUSY                    0x1031
#define EVT_REORDER                             0x1032
#define EVT_LIGHT_VERY_FASTFLASHING             0x1033
#define EVT_FUNCTION_LIGHT_VERY_FASTFLASHING    EVT_LIGHT_VERY_FASTFLASHING
#define EVT_SPEAKER_BUTTON_RELEASED             0x1034
#define EVT_REDIAL_BUTTON_RELEASED              0x1035
#define EVT_TRANSFER_BUTTON_RELEASED            0x1036
#define EVT_CONF_BUTTON_RELEASED                0x1037
#define EVT_DISCONNECTED                        0x1038
#define EVT_CONNECTED                           0x1039
#define EVT_ABANDONED                           0x103a
#define EVT_SUSPENDED                           0x103b
#define EVT_RESUMED                             0x103c
#define EVT_HELD                                0x103d
#define EVT_RETRIEVED                           0x103e
#define EVT_REJECTED                            0x103f
#define EVT_MESSAGE_BUTTON_PRESSED              0x1040
#define EVT_MESSAGE_BUTTON_RELEASED             0x1041
#define EVT_SUPERVISOR_BUTTON_PRESSED           0x1042
#define EVT_SUPERVISOR_BUTTON_RELEASED          0x1043
#define EVT_WRAPUP_BUTTON_PRESSED               0x1044
#define EVT_WRAPUP_BUTTON_RELEASED              0x1045
#define EVT_READY_BUTTON_PRESSED                0x1046
#define EVT_READY_BUTTON_RELEASED               0x1047

#define EVT_LOGON_BUTTON_PRESSED                0x1048
#define EVT_BREAK_BUTTON_PRESSED                0x1049

#define EVT_AUDIO_CHANGE                        0x104a
#define EVT_DISPLAY_MESSAGE                     0x104b

#define EVT_WORK_BUTTON_PRESSED                 0x104c
#define EVT_TALLY_BUTTON_PRESSED                0x104d
#define EVT_PROGRAM_BUTTON_PRESSED              0x104e
#define EVT_MUTE_BUTTON_PRESSED                 0x104f

#define EVT_ALERTING_AUTO_ANSWER                0x1050
#define EVT_MENU_BUTTON_RELEASED                0x1051
#define EVT_EXIT_BUTTON_RELEASED                0x1052
#define EVT_NEXT_BUTTON_RELEASED                0x1053
#define EVT_PREVIOUS_BUTTON_RELEASED            0x1054
#define EVT_SHIFT_BUTTON_PRESSED                0x1055
#define EVT_SHIFT_BUTTON_RELEASED               0x1056
#define EVT_PAGE_BUTTON_PRESSED                 0x1057
#define EVT_PAGE_BUTTON_RELEASED                0x1058
#define EVT_SOFT_BUTTON_RELEASED                0x1059

#define EVT_LINE_LIGHT_OFF                      0x1060
#define EVT_LINE_LIGHT_ON                       0x1061
#define EVT_LINE_LIGHT_FLASHING                 0x1062
#define EVT_LINE_LIGHT_FASTFLASHING             0x1063
#define EVT_LINE_LIGHT_VERY_FASTFLASHING        0x1064
#define EVT_LINE_LIGHT_QUICKFLASH               0x1065
#define EVT_LINE_LIGHT_WINK                     0x1066
#define EVT_LINE_LIGHT_SLOW_WINK                0x1067

#define EVT_FEATURE_LIGHT_OFF                   0x1068
#define EVT_FEATURE_LIGHT_ON                    0x1069
#define EVT_FEATURE_LIGHT_FLASHING              0x106A
#define EVT_FEATURE_LIGHT_FASTFLASHING          0x106B
#define EVT_FEATURE_LIGHT_VERY_FASTFLASHING     0x106C
#define EVT_FEATURE_LIGHT_QUICKFLASH            0x106D
#define EVT_FEATURE_LIGHT_WINK                  0x106E
#define EVT_FEATURE_LIGHT_SLOW_WINK             0x106F

#define EVT_SPEAKER_LIGHT_OFF                   0x1070
#define EVT_SPEAKER_LIGHT_ON                    0x1071
#define EVT_SPEAKER_LIGHT_FLASHING              0x1072
#define EVT_SPEAKER_LIGHT_FASTFLASHING          0x1073
#define EVT_SPEAKER_LIGHT_VERY_FASTFLASHING     0x1074
#define EVT_SPEAKER_LIGHT_QUICKFLASH            0x1075
#define EVT_SPEAKER_LIGHT_WINK                  0x1076
#define EVT_SPEAKER_LIGHT_SLOW_WINK             0x1077

#define EVT_MIC_LIGHT_OFF                       0x1078
#define EVT_MIC_LIGHT_ON                        0x1079
#define EVT_MIC_LIGHT_FLASHING                  0x107A
#define EVT_MIC_LIGHT_FASTFLASHING              0x107B
#define EVT_MIC_LIGHT_VERY_FASTFLASHING         0x107C
#define EVT_MIC_LIGHT_QUICKFLASH                0x107D
#define EVT_MIC_LIGHT_WINK                      0x107E
#define EVT_MIC_LIGHT_SLOW_WINK                 0x107F

#define EVT_HOLD_LIGHT_OFF                      0x1080
#define EVT_HOLD_LIGHT_ON                       0x1081
#define EVT_HOLD_LIGHT_FLASHING                 0x1082
#define EVT_HOLD_LIGHT_FASTFLASHING             0x1083
#define EVT_HOLD_LIGHT_VERY_FASTFLASHING        0x1084
#define EVT_HOLD_LIGHT_QUICKFLASH               0x1085
#define EVT_HOLD_LIGHT_WINK                     0x1086
#define EVT_HOLD_LIGHT_SLOW_WINK                0x1087

#define EVT_RELEASE_LIGHT_OFF                   0x1088
#define EVT_RELEASE_LIGHT_ON                    0x1089
#define EVT_RELEASE_LIGHT_FLASHING              0x108A
#define EVT_RELEASE_LIGHT_FASTFLASHING          0x108B
#define EVT_RELEASE_LIGHT_VERY_FASTFLASHING     0x108C
#define EVT_RELEASE_LIGHT_QUICKFLASH            0x108D
#define EVT_RELEASE_LIGHT_WINK                  0x108E
#define EVT_RELEASE_LIGHT_SLOW_WINK             0x108F

#define EVT_HELP_LIGHT_OFF                      0x1090
#define EVT_HELP_LIGHT_ON                       0x1091
#define EVT_HELP_LIGHT_FLASHING                 0x1092
#define EVT_HELP_LIGHT_FASTFLASHING             0x1093
#define EVT_HELP_LIGHT_VERY_FASTFLASHING        0x1094
#define EVT_HELP_LIGHT_QUICKFLASH               0x1095
#define EVT_HELP_LIGHT_WINK                     0x1096
#define EVT_HELP_LIGHT_SLOW_WINK                0x1097 

#define EVT_SUPERVISOR_LIGHT_OFF                0x1098
#define EVT_SUPERVISOR_LIGHT_ON                 0x1099
#define EVT_SUPERVISOR_LIGHT_FLASHING           0x109A
#define EVT_SUPERVISOR_LIGHT_FASTFLASHING       0x109B
#define EVT_SUPERVISOR_LIGHT_VERY_FASTFLASHING  0x109C
#define EVT_SUPERVISOR_LIGHT_QUICKFLASH         0x109D
#define EVT_SUPERVISOR_LIGHT_WINK               0x109E
#define EVT_SUPERVISOR_LIGHT_SLOW_WINK          0x109F

#define EVT_READY_LIGHT_OFF                     0x10A0
#define EVT_READY_LIGHT_ON                      0x10A1
#define EVT_READY_LIGHT_FLASHING                0x10A2
#define EVT_READY_LIGHT_FASTFLASHING            0x10A3
#define EVT_READY_LIGHT_VERY_FASTFLASHING       0x10A4
#define EVT_READY_LIGHT_QUICKFLASH              0x10A5
#define EVT_READY_LIGHT_WINK                    0x10A6
#define EVT_READY_LIGHT_SLOW_WINK               0x10A7

#define EVT_LOGON_LIGHT_OFF                     0x10A8
#define EVT_LOGON_LIGHT_ON                      0x10A9
#define EVT_LOGON_LIGHT_FLASHING                0x10AA
#define EVT_LOGON_LIGHT_FASTFLASHING            0x10AB
#define EVT_LOGON_LIGHT_VERY_FASTFLASHING       0x10AC
#define EVT_LOGON_LIGHT_QUICKFLASH              0x10AD
#define EVT_LOGON_LIGHT_WINK                    0x10AE
#define EVT_LOGON_LIGHT_SLOW_WINK               0x10AF

#define EVT_WRAPUP_LIGHT_OFF                    0x10B0
#define EVT_WRAPUP_LIGHT_ON                     0x10B1
#define EVT_WRAPUP_LIGHT_FLASHING               0x10B2
#define EVT_WRAPUP_LIGHT_FASTFLASHING           0x10B3
#define EVT_WRAPUP_LIGHT_VERY_FASTFLASHING      0x10B4
#define EVT_WRAPUP_LIGHT_QUICKFLASH             0x10B5
#define EVT_WRAPUP_LIGHT_WINK                   0x10B6
#define EVT_WRAPUP_LIGHT_SLOW_WINK              0x10B7

#define EVT_RING_LIGHT_OFF                      0x10B8
#define EVT_RING_LIGHT_ON                       0x10B9
#define EVT_RING_LIGHT_FLASHING                 0x10BA
#define EVT_RING_LIGHT_FASTFLASHING             0x10BB
#define EVT_RING_LIGHT_VERY_FASTFLASHING        0x10BC
#define EVT_RING_LIGHT_QUICKFLASH               0x10BD
#define EVT_RING_LIGHT_WINK                     0x10BE
#define EVT_RING_LIGHT_SLOW_WINK                0x10BF 

#define EVT_ANSWER_LIGHT_OFF                    0x10C0
#define EVT_ANSWER_LIGHT_ON                     0x10C1
#define EVT_ANSWER_LIGHT_FLASHING               0x10C2
#define EVT_ANSWER_LIGHT_FASTFLASHING           0x10C3
#define EVT_ANSWER_LIGHT_VERY_FASTFLASHING      0x10C4
#define EVT_ANSWER_LIGHT_QUICKFLASH             0x10C5
#define EVT_ANSWER_LIGHT_WINK                   0x10C6
#define EVT_ANSWER_LIGHT_SLOW_WINK              0x10C7

#define EVT_PROGRAM_LIGHT_OFF                   0x10C8
#define EVT_PROGRAM_LIGHT_ON                    0x10C9
#define EVT_PROGRAM_LIGHT_FLASHING              0x10CA
#define EVT_PROGRAM_LIGHT_FASTFLASHING          0x10CB
#define EVT_PROGRAM_LIGHT_VERY_FASTFLASHING     0x10CC
#define EVT_PROGRAM_LIGHT_QUICKFLASH            0x10CD
#define EVT_PROGRAM_LIGHT_WINK                  0x10CE
#define EVT_PROGRAM_LIGHT_MEDIUM_WINK           0x10CF

#define EVT_MESSAGE_LIGHT_OFF                   0x10D0
#define EVT_MESSAGE_LIGHT_ON                    0x10D1
#define EVT_MESSAGE_LIGHT_FLASHING              0x10D2
#define EVT_MESSAGE_LIGHT_FASTFLASHING          0x10D3
#define EVT_MESSAGE_LIGHT_VERY_FASTFLASHING     0x10D4
#define EVT_MESSAGE_LIGHT_QUICKFLASH            0x10D5
#define EVT_MESSAGE_LIGHT_WINK                  0x10D6
#define EVT_MESSAGE_LIGHT_SLOW_WINK             0x10D7

#define EVT_TRANSFER_LIGHT_OFF                  0x10D8
#define EVT_TRANSFER_LIGHT_ON                   0x10D9
#define EVT_TRANSFER_LIGHT_FLASHING             0x10DA
#define EVT_TRANSFER_LIGHT_FASTFLASHING         0x10DB
#define EVT_TRANSFER_LIGHT_VERY_FASTFLASHING    0x10DC
#define EVT_TRANSFER_LIGHT_QUICKFLASH           0x10DD
#define EVT_TRANSFER_LIGHT_WINK                 0x10DE
#define EVT_TRANSFER_LIGHT_MEDIUM_WINK          0x10DF

#define EVT_CONFERENCE_LIGHT_OFF                0x10E0
#define EVT_CONFERENCE_LIGHT_ON                 0x10E1
#define EVT_CONFERENCE_LIGHT_FLASHING           0x10E2
#define EVT_CONFERENCE_LIGHT_FASTFLASHING       0x10E3
#define EVT_CONFERENCE_LIGHT_VERY_FASTFLASHING  0x10E4
#define EVT_CONFERENCE_LIGHT_QUICKFLASH         0x10E5
#define EVT_CONFERENCE_LIGHT_WINK               0x10E6
#define EVT_CONFERENCE_LIGHT_MEDIUM_WINK        0x10E7

#define EVT_SOFT_LIGHT_OFF                      0x10E8
#define EVT_SOFT_LIGHT_ON                       0x10E9
#define EVT_SOFT_LIGHT_FLASHING                 0x10EA
#define EVT_SOFT_LIGHT_FASTFLASHING             0x10EB
#define EVT_SOFT_LIGHT_VERY_FASTFLASHING        0x10EC
#define EVT_SOFT_LIGHT_QUICKFLASH               0x10ED
#define EVT_SOFT_LIGHT_WINK                     0x10EE
#define EVT_SOFT_LIGHT_SLOW_WINK                0x10EF

#define EVT_MENU_LIGHT_OFF                      0x10F0
#define EVT_MENU_LIGHT_ON                       0x10F1
#define EVT_MENU_LIGHT_FLASHING                 0x10F2
#define EVT_MENU_LIGHT_FASTFLASHING             0x10F3
#define EVT_MENU_LIGHT_VERY_FASTFLASHING        0x10F4
#define EVT_MENU_LIGHT_QUICKFLASH               0x10F5
#define EVT_MENU_LIGHT_WINK                     0x10F6 
#define EVT_MENU_LIGHT_SLOW_WINK                0x10F7

#define EVT_CALLWAITING_LIGHT_OFF               0x10F8
#define EVT_CALLWAITING_LIGHT_ON                0x10F9
#define EVT_CALLWAITING_LIGHT_FLASHING          0x10FA
#define EVT_CALLWAITING_LIGHT_FASTFLASHING      0x10FB
#define EVT_CALLWAITING_LIGHT_VERY_FASTFLASHING 0x10FC
#define EVT_CALLWAITING_LIGHT_QUICKFLASH        0x10FD
#define EVT_CALLWAITING_LIGHT_WINK              0x10FE
#define EVT_CALLWAITING_LIGHT_SLOW_WINK         0x10FF

#define EVT_REDIAL_LIGHT_OFF                    0x1100
#define EVT_REDIAL_LIGHT_ON                     0x1101
#define EVT_REDIAL_LIGHT_FLASHING               0x1102
#define EVT_REDIAL_LIGHT_FASTFLASHING           0x1103
#define EVT_REDIAL_LIGHT_VERY_FASTFLASHING      0x1104
#define EVT_REDIAL_LIGHT_QUICKFLASH             0x1105
#define EVT_REDIAL_LIGHT_WINK                   0x1106
#define EVT_REDIAL_LIGHT_SLOW_WINK              0x1107

#define EVT_PAGE_LIGHT_OFF                      0x1108
#define EVT_PAGE_LIGHT_ON                       0x1109
#define EVT_PAGE_LIGHT_FLASHING                 0x110A
#define EVT_PAGE_LIGHT_FASTFLASHING             0x110B
#define EVT_PAGE_LIGHT_VERY_FASTFLASHING        0x110C
#define EVT_PAGE_LIGHT_QUICKFLASH               0x110D

#define EVT_CTRL_BUTTON_PRESSED                 0x110E
#define EVT_CTRL_BUTTON_RELEASED                0x110F

#define EVT_CANCEL_BUTTON_PRESSED               0x1110
#define EVT_CANCEL_BUTTON_RELEASED              0x1111

#define EVT_MIC_BUTTON_PRESSED                  0x1112
#define EVT_MIC_BUTTON_RELEASED                 0x1113

#define EVT_FLASH_BUTTON_PRESSED                0x1114
#define EVT_FLASH_BUTTON_RELEASED               0x1115

#define EVT_DIRECTORY_BUTTON_PRESSED            0x1116
#define EVT_DIRECTORY_BUTTON_RELEASED           0x1117

#define EVT_HANDSFREE_BUTTON_PRESSED            0x1118
#define EVT_HANDSFREE_BUTTON_RELEASED           0x1119

#define EVT_RINGTONE_BUTTON_PRESSED             0x111A
#define EVT_RINGTONE_BUTTON_RELEASED            0x111B

#define EVT_SAVE_BUTTON_PRESSED                 0x111C
#define EVT_SAVE_BUTTON_RELEASED                0x111D


#define EVT_MUTE_LIGHT_OFF                      0x111E
#define EVT_MUTE_LIGHT_ON                       0x111F
#define EVT_MUTE_LIGHT_FLASHING                 0x1120
#define EVT_MUTE_LIGHT_FASTFLASHING             0x1121
#define EVT_MUTE_LIGHT_VERY_FASTFLASHING        0x1122
#define EVT_MUTE_LIGHT_QUICKFLASH               0x1123
#define EVT_MUTE_LIGHT_WINK                     0x1124
#define EVT_MUTE_LIGHT_SLOW_WINK                0x1125
#define EVT_MUTE_LIGHT_MEDIUM_WINK              0x1126

#define EVT_HANDSFREE_LIGHT_OFF                 0x1127
#define EVT_HANDSFREE_LIGHT_ON                  0x1128
#define EVT_HANDSFREE_LIGHT_FLASHING            0x1129
#define EVT_HANDSFREE_LIGHT_FASTFLASHING        0x112A
#define EVT_HANDSFREE_LIGHT_VERY_FASTFLASHING   0x112B
#define EVT_HANDSFREE_LIGHT_QUICKFLASH          0x112C
#define EVT_HANDSFREE_LIGHT_WINK                0x112D
#define EVT_HANDSFREE_LIGHT_SLOW_WINK           0x112E
#define EVT_HANDSFREE_LIGHT_MEDIUM_WINK         0x112F

#define EVT_DIRECTORY_LIGHT_OFF                 0x1130
#define EVT_DIRECTORY_LIGHT_ON                  0x1131
#define EVT_DIRECTORY_LIGHT_FLASHING            0x1132
#define EVT_DIRECTORY_LIGHT_FASTFLASHING        0x1133
#define EVT_DIRECTORY_LIGHT_VERY_FASTFLASHING   0x1134
#define EVT_DIRECTORY_LIGHT_QUICKFLASH          0x1135
#define EVT_DIRECTORY_LIGHT_WINK                0x1136
#define EVT_DIRECTORY_LIGHT_SLOW_WINK           0x1137
#define EVT_DIRECTORY_LIGHT_MEDIUM_WINK         0x1138

#define EVT_RINGTONE_LIGHT_OFF                  0x1139
#define EVT_RINGTONE_LIGHT_ON                   0x113A
#define EVT_RINGTONE_LIGHT_FLASHING             0x113B
#define EVT_RINGTONE_LIGHT_FASTFLASHING         0x113C
#define EVT_RINGTONE_LIGHT_VERY_FASTFLASHING    0x113D
#define EVT_RINGTONE_LIGHT_QUICKFLASH           0x113E
#define EVT_RINGTONE_LIGHT_WINK                 0x113F
#define EVT_RINGTONE_LIGHT_SLOW_WINK            0x1140
#define EVT_RINGTONE_LIGHT_MEDIUM_WINK          0x1141

#define EVT_SAVE_LIGHT_OFF                      0x1142
#define EVT_SAVE_LIGHT_ON                       0x1143
#define EVT_SAVE_LIGHT_FLASHING                 0x1144
#define EVT_SAVE_LIGHT_FASTFLASHING             0x1145
#define EVT_SAVE_LIGHT_VERY_FASTFLASHING        0x1146
#define EVT_SAVE_LIGHT_QUICKFLASH               0x1147
#define EVT_SAVE_LIGHT_WINK                     0x1148
#define EVT_SAVE_LIGHT_SLOW_WINK                0x1149
#define EVT_SAVE_LIGHT_MEDIUM_WINK              0x114A 

#define EVT_FUNCTION_LIGHT_WINK                 0x114B
#define EVT_FUNCTION_LIGHT_SLOW_WINK            0x114C
#define EVT_FUNCTION_LIGHT_MEDIUM_WINK          0x114D

#define EVT_CALLWAITING_BUTTON_PRESSED          0x114E
#define EVT_CALLWAITING_BUTTON_RELEASED         0x114F

#define EVT_PARK_BUTTON_PRESSED                 0x1150
#define EVT_PARK_BUTTON_RELEASED                0x1151

#define EVT_NEWCALL_BUTTON_PRESSED              0x1152
#define EVT_NEWCALL_BUTTON_RELEASED             0x1153

#define EVT_PARK_LIGHT_OFF                      0x1154
#define EVT_PARK_LIGHT_ON                       0x1155
#define EVT_PARK_LIGHT_FLASHING                 0x1156
#define EVT_PARK_LIGHT_FASTFLASHING             0x1157
#define EVT_PARK_LIGHT_VERY_FASTFLASHING        0x1158
#define EVT_PARK_LIGHT_QUICKFLASH               0x1159
#define EVT_PARK_LIGHT_WINK                     0x115A
#define EVT_PARK_LIGHT_SLOW_WINK                0x115B
#define EVT_PARK_LIGHT_MEDIUM_WINK              0x115C

#define EVT_SCROLL_BUTTON_PRESSED               0x115D
#define EVT_SCROLL_BUTTON_RELEASED              0x115E

#define EVT_DIVERT_BUTTON_PRESSED               0x115F
#define EVT_DIVERT_BUTTON_RELEASED              0x1160

#define EVT_GROUP_BUTTON_PRESSED                0x1161
#define EVT_GROUP_BUTTON_RELEASED               0x1162

#define EVT_SPEEDDIAL_BUTTON_PRESSED            0x1163
#define EVT_SPEEDDIAL_BUTTON_RELEASED           0x1164

#define EVT_DND_BUTTON_PRESSED                  0x1165
#define EVT_DND_BUTTON_RELEASED                 0x1166

#define EVT_ENTER_BUTTON_PRESSED                0x1167
#define EVT_ENTER_BUTTON_RELEASED               0x1168

#define EVT_CLEAR_BUTTON_PRESSED                0x1169
#define EVT_CLEAR_BUTTON_RELEASED               0x116A

#define EVT_DESTINATION_BUTTON_PRESSED          0x116B
#define EVT_DESTINATION_BUTTON_RELEASED         0x116C

#define EVT_DND_LIGHT_OFF                       0x116D
#define EVT_DND_LIGHT_ON                        0x116E
#define EVT_DND_LIGHT_FLASHING                  0x116F
#define EVT_DND_LIGHT_FASTFLASHING              0x1170
#define EVT_DND_LIGHT_VERY_FASTFLASHING         0x1171
#define EVT_DND_LIGHT_QUICKFLASH                0x1172
#define EVT_DND_LIGHT_WINK                      0x1173
#define EVT_DND_LIGHT_SLOW_WINK                 0x1174
#define EVT_DND_LIGHT_MEDIUM_WINK               0x1175

#define EVT_GROUP_LIGHT_OFF                     0x1176
#define EVT_GROUP_LIGHT_ON                      0x1177
#define EVT_GROUP_LIGHT_FLASHING                0x1178
#define EVT_GROUP_LIGHT_FASTFLASHING            0x1179
#define EVT_GROUP_LIGHT_VERY_FASTFLASHING       0x117A
#define EVT_GROUP_LIGHT_QUICKFLASH              0x117B
#define EVT_GROUP_LIGHT_WINK                    0x117C
#define EVT_GROUP_LIGHT_SLOW_WINK               0x117D
#define EVT_GROUP_LIGHT_MEDIUM_WINK             0x117E

#define EVT_DIVERT_LIGHT_OFF                    0x117F
#define EVT_DIVERT_LIGHT_ON                     0x1180
#define EVT_DIVERT_LIGHT_FLASHING               0x1181
#define EVT_DIVERT_LIGHT_FASTFLASHING           0x1182
#define EVT_DIVERT_LIGHT_VERY_FASTFLASHING      0x1183
#define EVT_DIVERT_LIGHT_QUICKFLASH             0x1184
#define EVT_DIVERT_LIGHT_WINK                   0x1185 
#define EVT_DIVERT_LIGHT_SLOW_WINK              0x1186
#define EVT_DIVERT_LIGHT_MEDIUM_WINK            0x1187

#define EVT_SCROLL_LIGHT_OFF                    0x1188
#define EVT_SCROLL_LIGHT_ON                     0x1189
#define EVT_SCROLL_LIGHT_FLASHING               0x118A
#define EVT_SCROLL_LIGHT_FASTFLASHING           0x118B
#define EVT_SCROLL_LIGHT_VERY_FASTFLASHING      0x118C
#define EVT_SCROLL_LIGHT_QUICKFLASH             0x118D
#define EVT_SCROLL_LIGHT_WINK                   0x118E
#define EVT_SCROLL_LIGHT_SLOW_WINK              0x118F
#define EVT_SCROLL_LIGHT_MEDIUM_WINK            0x1190

#define EVT_CALLBACK_BUTTON_PRESSED             0x1191
#define EVT_CALLBACK_BUTTON_RELEASED            0x1192

#define EVT_FLASH_LIGHT_OFF                     0x1193
#define EVT_FLASH_LIGHT_ON                      0x1194
#define EVT_FLASH_LIGHT_FLASHING                0x1195
#define EVT_FLASH_LIGHT_FASTFLASHING            0x1196
#define EVT_FLASH_LIGHT_VERY_FASTFLASHING       0x1197
#define EVT_FLASH_LIGHT_QUICKFLASH              0x1198
#define EVT_FLASH_LIGHT_WINK                    0x1199
#define EVT_FLASH_LIGHT_SLOW_WINK               0x119A
#define EVT_FLASH_LIGHT_MEDIUM_WINK             0x119B

#define EVT_MODE_BUTTON_PRESSED                 0x119C
#define EVT_MODE_BUTTON_RELEASED                0x119D

#define EVT_SPEAKER_LIGHT_MEDIUM_WINK           0x119E
#define EVT_MESSAGE_LIGHT_MEDIUM_WINK           0x119F

#define EVT_SPEEDDIAL_LIGHT_OFF                 0x11A0
#define EVT_SPEEDDIAL_LIGHT_ON                  0x11A1
#define EVT_SPEEDDIAL_LIGHT_FLASHING            0x11A2
#define EVT_SPEEDDIAL_LIGHT_FASTFLASHING        0x11A3
#define EVT_SPEEDDIAL_LIGHT_VERY_FASTFLASHING   0x11A4
#define EVT_SPEEDDIAL_LIGHT_QUICKFLASH          0x11A5
#define EVT_SPEEDDIAL_LIGHT_WINK                0x11A6
#define EVT_SPEEDDIAL_LIGHT_SLOW_WINK           0x11A7
#define EVT_SPEEDDIAL_LIGHT_MEDIUM_WINK         0x11A8

#define EVT_SELECT_BUTTON_PRESSED               0x11A9
#define EVT_SELECT_BUTTON_RELEASED              0x11AA

#define EVT_PAUSE_BUTTON_PRESSED                0x11AB
#define EVT_PAUSE_BUTTON_RELEASED               0x11AC

#define EVT_INTERCOM_BUTTON_PRESSED             0x11AD
#define EVT_INTERCOM_BUTTON_RELEASED            0x11AE

#define EVT_INTERCOM_LIGHT_OFF                  0x11AF
#define EVT_INTERCOM_LIGHT_ON                   0x11B0
#define EVT_INTERCOM_LIGHT_FLASHING             0x11B1
#define EVT_INTERCOM_LIGHT_FASTFLASHING         0x11B2
#define EVT_INTERCOM_LIGHT_VERY_FASTFLASHING    0x11B3
#define EVT_INTERCOM_LIGHT_QUICKFLASH           0x11B4
#define EVT_INTERCOM_LIGHT_WINK                 0x11B5
#define EVT_INTERCOM_LIGHT_SLOW_WINK            0x11B6
#define EVT_INTERCOM_LIGHT_MEDIUM_WINK          0x11B7

#define EVT_CFWD_LIGHT_OFF                      0x11B8
#define EVT_CFWD_LIGHT_ON                       0x11B9
#define EVT_CFWD_LIGHT_FLASHING                 0x11BA
#define EVT_CFWD_LIGHT_FASTFLASHING             0x11BB
#define EVT_CFWD_LIGHT_VERY_FASTFLASHING        0x11BC
#define EVT_CFWD_LIGHT_QUICKFLASH               0x11BD
#define EVT_CFWD_LIGHT_WINK                     0x11BE
#define EVT_CFWD_LIGHT_SLOW_WINK                0x11BF
#define EVT_CFWD_LIGHT_MEDIUM_WINK              0x11C0

#define EVT_CFWD_BUTTON_PRESSED                 0x11C1
#define EVT_CFWD_BUTTON_RELEASED                0x11C2

#define EVT_SPECIAL_LIGHT_OFF                   0x11C3
#define EVT_SPECIAL_LIGHT_ON                    0x11C4
#define EVT_SPECIAL_LIGHT_FLASHING              0x11C5
#define EVT_SPECIAL_LIGHT_FASTFLASHING          0x11C6
#define EVT_SPECIAL_LIGHT_VERY_FASTFLASHING     0x11C7
#define EVT_SPECIAL_LIGHT_QUICKFLASH            0x11C8
#define EVT_SPECIAL_LIGHT_WINK                  0x11C9
#define EVT_SPECIAL_LIGHT_SLOW_WINK             0x11CA
#define EVT_SPECIAL_LIGHT_MEDIUM_WINK           0x11CB

#define EVT_SPECIAL_BUTTON_PRESSED              0x11CC
#define EVT_SPECIAL_BUTTON_RELEASED             0x11CD

#define EVT_FORWARD_LIGHT_OFF                   0x11CE
#define EVT_FORWARD_LIGHT_ON                    0x11CF
#define EVT_FORWARD_LIGHT_FLASHING              0x11D0
#define EVT_FORWARD_LIGHT_FASTFLASHING          0x11D1
#define EVT_FORWARD_LIGHT_VERY_FASTFLASHING     0x11D2
#define EVT_FORWARD_LIGHT_QUICKFLASH            0x11D3
#define EVT_FORWARD_LIGHT_WINK                  0x11D4
#define EVT_FORWARD_LIGHT_SLOW_WINK             0x11D5
#define EVT_FORWARD_LIGHT_MEDIUM_WINK           0x11D6

#define EVT_FORWARD_BUTTON_PRESSED              0x11D7
#define EVT_FORWARD_BUTTON_RELEASED             0x11D8

#define EVT_OUTGOING_LIGHT_OFF                  0x11D9
#define EVT_OUTGOING_LIGHT_ON                   0x11DA
#define EVT_OUTGOING_LIGHT_FLASHING             0x11DB
#define EVT_OUTGOING_LIGHT_FASTFLASHING         0x11DC
#define EVT_OUTGOING_LIGHT_VERY_FASTFLASHING    0x11DD
#define EVT_OUTGOING_LIGHT_QUICKFLASH           0x11DE
#define EVT_OUTGOING_LIGHT_WINK                 0x11DF
#define EVT_OUTGOING_LIGHT_SLOW_WINK            0x11E0
#define EVT_OUTGOING_LIGHT_MEDIUM_WINK          0x11E1

#define EVT_OUTGOING_BUTTON_PRESSED             0x11E2
#define EVT_OUTGOING_BUTTON_RELEASED            0x11E3

#define EVT_BACKSPACE_LIGHT_OFF                 0x11E4
#define EVT_BACKSPACE_LIGHT_ON                  0x11E5
#define EVT_BACKSPACE_LIGHT_FLASHING            0x11E6
#define EVT_BACKSPACE_LIGHT_FASTFLASHING        0x11E7
#define EVT_BACKSPACE_LIGHT_VERY_FASTFLASHING   0x11E8
#define EVT_BACKSPACE_LIGHT_QUICKFLASH          0x11E9
#define EVT_BACKSPACE_LIGHT_WINK                0x11EA
#define EVT_BACKSPACE_LIGHT_SLOW_WINK           0x11EB
#define EVT_BACKSPACE_LIGHT_MEDIUM_WINK         0x11EC

#define EVT_BACKSPACE_BUTTON_PRESSED            0x11ED
#define EVT_BACKSPACE_BUTTON_RELEASED           0x11EE

#define EVT_START_TONE                          0x11EF
#define EVT_STOP_TONE                           0x11F0
#define EVT_FLASHHOOK                           0x11F1

#define EVT_LINE_BUTTON_RELEASED                0x11F2
#define EVT_FEATURE_BUTTON_RELEASED             0x11F3
#define EVT_MUTE_BUTTON_RELEASED                0x11F4
#define EVT_HELP_BUTTON_RELEASED                0x11F5
#define EVT_LOGON_BUTTON_RELEASED               0x11F6
#define EVT_ANSWER_BUTTON_RELEASED              0x11F7
#define EVT_PROGRAM_BUTTON_RELEASED             0x11F8
#define EVT_CONFERENCE_BUTTON_RELEASED          0x11F9
#define EVT_RECALL_BUTTON_RELEASED              0x11FA
#define EVT_BREAK_BUTTON_RELEASED               0x11FB
#define EVT_WORK_BUTTON_RELEASED                0x11FC
#define EVT_TALLY_BUTTON_RELEASED               0x11FD

#define EVT_EXPAND_LIGHT_OFF                    0x1200
#define EVT_EXPAND_LIGHT_ON                     0x1201
#define EVT_EXPAND_LIGHT_FLASHING               0x1202
#define EVT_EXPAND_LIGHT_FASTFLASHING           0x1203
#define EVT_EXPAND_LIGHT_VERY_FASTFLASHING      0x1204
#define EVT_EXPAND_LIGHT_QUICKFLASH             0x1205
#define EVT_EXPAND_LIGHT_WINK                   0x1206
#define EVT_EXPAND_LIGHT_SLOW_WINK              0x1207
#define EVT_EXPAND_LIGHT_MEDIUM_WINK            0x1208

#define EVT_EXPAND_BUTTON_PRESSED               0x1209
#define EVT_EXPAND_BUTTON_RELEASED              0x120A

#define EVT_SERVICES_LIGHT_OFF                  0x1210
#define EVT_SERVICES_LIGHT_ON                   0x1211
#define EVT_SERVICES_LIGHT_FLASHING             0x1212
#define EVT_SERVICES_LIGHT_FASTFLASHING         0x1213
#define EVT_SERVICES_LIGHT_VERY_FASTFLASHING    0x1214
#define EVT_SERVICES_LIGHT_QUICKFLASH           0x1215
#define EVT_SERVICES_LIGHT_WINK                 0x1216
#define EVT_SERVICES_LIGHT_SLOW_WINK            0x1217
#define EVT_SERVICES_LIGHT_MEDIUM_WINK          0x1218

#define EVT_SERVICES_BUTTON_PRESSED             0x1219
#define EVT_SERVICES_BUTTON_RELEASED            0x121A

#define EVT_HEADSET_LIGHT_OFF                   0x1220
#define EVT_HEADSET_LIGHT_ON                    0x1221
#define EVT_HEADSET_LIGHT_FLASHING              0x1222
#define EVT_HEADSET_LIGHT_FASTFLASHING          0x1223
#define EVT_HEADSET_LIGHT_VERY_FASTFLASHING     0x1224
#define EVT_HEADSET_LIGHT_QUICKFLASH            0x1225
#define EVT_HEADSET_LIGHT_WINK                  0x1226
#define EVT_HEADSET_LIGHT_SLOW_WINK             0x1227
#define EVT_HEADSET_LIGHT_MEDIUM_WINK           0x1228

#define EVT_HEADSET_BUTTON_PRESSED              0x1229
#define EVT_HEADSET_BUTTON_RELEASED             0x122A

#define EVT_NAVIGATION_BUTTON_PRESSED           0x1239
#define EVT_NAVIGATION_BUTTON_RELEASED          0x123A

#define EVT_COPY_LIGHT_OFF                      0x1240
#define EVT_COPY_LIGHT_ON                       0x1241
#define EVT_COPY_LIGHT_FLASHING                 0x1242
#define EVT_COPY_LIGHT_FASTFLASHING             0x1243
#define EVT_COPY_LIGHT_VERY_FASTFLASHING        0x1244
#define EVT_COPY_LIGHT_QUICKFLASH               0x1245
#define EVT_COPY_LIGHT_WINK                     0x1246
#define EVT_COPY_LIGHT_SLOW_WINK                0x1247
#define EVT_COPY_LIGHT_MEDIUM_WINK              0x1248

#define EVT_COPY_BUTTON_PRESSED                 0x1249
#define EVT_COPY_BUTTON_RELEASED                0x124A

#define EVT_LINE_LIGHT_MEDIUM_WINK              0x1250
#define EVT_MIC_LIGHT_MEDIUM_WINK               0x1251 
#define EVT_HOLD_LIGHT_MEDIUM_WINK              0x1252
#define EVT_RELEASE_LIGHT_MEDIUM_WINK           0x1253
#define EVT_HELP_LIGHT_MEDIUM_WINK              0x1254
#define EVT_SUPERVISOR_LIGHT_MEDIUM_WINK        0x1255
#define EVT_READY_LIGHT_MEDIUM_WINK             0x1256
#define EVT_LOGON_LIGHT_MEDIUM_WINK             0x1257
#define EVT_WRAPUP_LIGHT_MEDIUM_WINK            0x1258
#define EVT_RING_LIGHT_MEDIUM_WINK              0x1259
#define EVT_ANSWER_LIGHT_MEDIUM_WINK            0x125A
#define EVT_PROGRAM_LIGHT_SLOW_WINK             0x125B
#define EVT_TRANSFER_LIGHT_SLOW_WINK            0x125C
#define EVT_CONFERENCE_LIGHT_SLOW_WINK          0x125D
#define EVT_SOFT_LIGHT_MEDIUM_WINK              0x125E 
#define EVT_MENU_LIGHT_MEDIUM_WINK              0x125F
#define EVT_CALLWAITING_LIGHT_MEDIUM_WINK       0x1260 
#define EVT_REDIAL_LIGHT_MEDIUM_WINK            0x1261
#define EVT_PAGE_LIGHT_MEDIUM_WINK              0x1262
#define EVT_FEATURE_LIGHT_MEDIUM_WINK           0x1263
#define EVT_PAGE_LIGHT_WINK                     0x1264
#define EVT_PAGE_LIGHT_SLOW_WINK                0x1265
#define EVT_TIME_AND_DATE                       0x1266

#define EVT_CISCO_SCCP_CALL_INFO                0x1280

// Currently, NTiEventDCC uses events ranged from DCC_EVENT_BASE to DCC_EVENT_MAX

#endif

// End if NTiEventDCC.h
