//
//  Copyright (c) 1999-2002 by AudioCodes USA, Inc.
//  All rights reserved.
//
//  NV_Wrap.h
//      SmartWORKS API declaration for backward compatibility for NVDSP definitions
//
//  AUDIOCODES USA, INC. PROPRIETARY.
//

#ifndef _INC_NV_WRAP_H
#define _INC_NV_WRAP_H


//
// MT_RESULT return values (backwards compatibility)
//

#ifndef NO_COMPAT_CODES

#define RET_OK               MT_RET_OK              // Function call successful
#define RET_NO_DIGIT         MT_RET_NO_DIGIT        // No digit avail (MTReadDigit/readDigit)
#define RET_STARTED          MT_RET_STARTED         // System is already started
#define RET_NOT_STARTED      MT_RET_NOT_STARTED     // System is not started
#define RET_MALFUNCTION      MT_RET_MALFUNCTION     // Hardware failed during initialization
#define RET_INVALID_FUNC     MT_RET_INVALID_FUNC    // Function code is not valid
#define RET_INVALID_HW_INT   MT_RET_INVALID_HW_INT  // Bad hardware IRQ at initialization
#define RET_INVALID_CHANNEL  MT_RET_INVALID_CHANNEL // Channel number is out of range
#define RET_BUSY             MT_RET_BUSY            // Channel is busy
#define RET_IDLE             MT_RET_IDLE            // Channel is idle
#define RET_INVALID_PARAM    MT_RET_INVALID_PARAM   // Invalid argument passed to function
#define RET_NOT_AVAILABLE    MT_RET_NOT_AVAILABLE   // Feature is not available
#define RET_EXTENDED_ERROR   MT_RET_EXTENDED_ERROR  // Extended err - NVGetLastError() for info
#define RET_SYS_ERROR        MT_RET_EXTENDED_ERROR  // System err
#define RET_NO_MUX           MT_RET_NO_MUX          // MUX not available
#define RET_MUX_ON           MT_RET_MUX_ON          // MUX system was already started
#define RET_MUX_OFF          MT_RET_MUX_OFF         // MUX system was not started
#define RET_BAD_JOIN         MT_RET_BAD_JOIN        // Invalid crosspoint coordinates
#define RET_BAD_CURSOR       MT_RET_BAD_CURSOR      // Invalid index offset


//
// Event results
//

#define XRET_OK              MT_XRET_OK          // Function call successful
#define XRET_BADHANDLE       MT_XRET_BADHANDLE   // (historical - not used)
#define XRET_QFULL           MT_XRET_QFULL       // Event queue has reached maximum
#define XRET_QEMPTY          MT_XRET_QEMPTY      // Event queue is empty
#define XRET_BADFUNCTION     MT_XRET_BADFUNCTION // (historical - not used)
#define XRET_BADPARAM        MT_XRET_BADPARAM    // Invalid argument passed to function

#endif // NO_COMPAT_CODES


//
// 'id' argument to MTSetParam
//

#define SP_WINK_DELAY        0x204          // Delay before starting wink
#define SP_WINK_TIME         0x205          // Duration of outgoing wink


#define MTCheckLink     MTGetSysInfo    // Descriptive name for this function
#define MTStopLink      MTSysShutdown   // Descriptive name for this function
#define MTStartLink     MTSysStartup    // Descriptive name for this function

#define MTSetEvents     MTSetEventFilters       // Descriptive name for this function

#define MTWaitForVoiceEvent     MTWaitForEvent  // Descriptive name for this function
#define MTEnbHdlr       MTSetEventCallback      // Descriptive name for this function
#define MTDisHdlr       MTClearEventCallback    // Descriptive name for this function


#define MTSetGSTN       MTSetPSTN         // MTSetGSTN() is a old function name
#define PMT_GSTNREGS    PMT_PSTN

#define MTGetGSTN       MTGetPSTN         // MTGetGSTN() is a old function name

#define MTSetPxdEcho    MTSetECControl

// MTDSP compatible definitions
#define MTStreamBufStartEx  MTStartStreaming


#define MTClearDigits       MTClearDTMFDigits
#define MTControlDigits     MTControlToneQ


#if 0

DLLIMPEXPORT MT_RESULT
MTSM_ToneParams(
    USHORT              tone,
    MTSM_TONE           *toneParams
    );

DLLIMPEXPORT MT_RESULT
MTSM_Send(
    USHORT              nChannel,
    USHORT              tone
    );

DLLIMPEXPORT MT_RESULT
MTSM_StopSend(
    USHORT              nChannel,
    USHORT              tone
    );

DLLIMPEXPORT MT_RESULT
MTSM_Parameters(
    USHORT              nChannel,
    USHORT              parameter,
    USHORT              value
    );

DLLIMPEXPORT MT_RESULT
MTRoute(
    USHORT          src,
    USHORT          src_index,
    USHORT          dest,
    USHORT          dest_index,
    USHORT          mode,
    USHORT          dir
    );

DLLIMPEXPORT MT_RESULT
MTSetParam(
    CHANNEL nChannel,
    USHORT id,
    USHORT value
    );

#endif


#endif

// End of NV_Wrap.h
