//
//  Copyright (c) 1999-2009 by AudioCodes, Inc.
//  All rights reserved.
//
// SysLimits.h
//      Define system version and limitations for SmartWORKS products
//
//  AUDIOCODES, INC. PROPRIETARY.
//

#ifndef _INC_SYSLIMITS_H
#define _INC_SYSLIMITS_H

//
// SmartWORKS Version
//
#define VER_SZ_COMPANY_NAME    "AudioCodes, Inc."
#define VER_SZ_COMPANY_NAME_UC "AUDIOCODES, INC."

#define VER_MAJOR        5
#define VER_SZ_MAJOR    "5"

#define VER_MINOR        3
#define VER_SZ_MINOR    "3"

#define VER_INTERNAL     0
#define VER_SZ_INTERNAL "0"

//
// System resource limitation
//

#define MAX_BRD_DEVICES             32  // Max of NTI board devices supported
#define MAX_CH_DEVICES_PER_BRD      128 // Max of channel devices per NTI board
#define MAX_CH_DEVICES              512 // Max of NTI channels supported in SDK
#define MAX_DLL_ATTACHED            512 // Maximum number of DLLs that can attach to the driver at once

#define MAX_SUMM_FUNC               256 // Max of NTI summation functions supported
#define MAX_INPUTS_PER_SUMM         32  // Max of inputs per NTI summation function

#define MAX_NFAS                    MAX_BRD_DEVICES // Max of NFAS supported in SDK
#define MAX_NFAS_CHANNEL            335 // Max of channels per NFAS (24*14 -1)

#define MIN_SMSIZE                  0x2000  // Minimum MTADAPTER_CONFIG.SMSize
#define MAX_SMSIZE                  0x100000 // Maximum MTADAPTER_CONFIG.SMSize
#define MAX_EEPROM_LENGTH           128 // Maximum user configurable EEPROM size

#define MAX_IP_ELEMENT              8   // Maximum number of MT_IP_ELEMENTs

#endif

// End of SysLimits.h
