//---------------------------------------------------------------------------
#ifndef conf_mainH
#define conf_mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <Dialogs.hpp>
#include <SysUtils.hpp>
#include <FileCtrl.hpp>

//---------------------------------------------------------------------------

#include "..\TFServer\ivr_defs.h"	// TELEFLOW_REG_KEY

// Registry key where TeleFlow Configuration settings are stored
#define TFCONFIG_REG_KEY  TELEFLOW_REG_KEY "\\TeleFlow Server"

#define TFSERVICE_REG_KEY "SYSTEM\\CurrentControlSet\\Services\\TFServer"

//---------------------------------------------------------------------------

class TFormConf : public TForm
{
__published:	// IDE-managed Components
   TMainMenu *mnuMain;
   TMenuItem *mnuFile;
   TMenuItem *mnuFileExit;
   TOpenDialog *dlgOpen;
   TButton *btnActiveTAL;
   TEdit *efLogDir;
   TButton *btnLogDir;
   TEdit *efLogLines;
   TEdit *efActiveTAL;
   TButton *OKButton;
   TButton *CancelButton;
   TButton *AdvancedButton;
   TMenuItem *mnuHelp;
   TMenuItem *mnuHelpAbout;
   TMenuItem *mnuHelpContents;
   TComboBox *ComboBoxTHardware;
	TLabel *lblTHardware;
	TLabel *lblActiveTAL;
	TLabel *lblLogDir;
	TLabel *lblLogLines;
	TBevel *Bevel1;
	TEdit *efMaxLogFileSize;
	TLabel *lblMaxLogFileSize;
	TLabel *lblkB;
	TCheckBox *cbUnlimitedLogFileSize;
   TCheckBox *cbStartServiceAutomatically;
   TButton *EditTALButton;
   TCheckBox *cbLogSRAudio;
    void __fastcall btnActiveTALClick(TObject *Sender);
    void __fastcall btnLogDirClick(TObject *Sender);
    void __fastcall mnuFileExitClick(TObject *Sender);
    void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall OKButtonClick(TObject *Sender);
	void __fastcall CancelButtonClick(TObject *Sender);
	void __fastcall AdvancedButtonClick(TObject *Sender);
	void __fastcall mnuHelpContentsClick(TObject *Sender);
	void __fastcall mnuHelpAboutClick(TObject *Sender);
	void __fastcall efLogLinesExit(TObject *Sender);
	void __fastcall efMaxLogFileSizeExit(TObject *Sender);
	void __fastcall cbUnlimitedLogFileSizeClick(TObject *Sender);
   void __fastcall EditTALButtonClick(TObject *Sender);
private:	// User declarations
   bool bUpdateReg;
   int maxLogFileSize;
	bool __fastcall ValidLogLines(void);
	bool __fastcall ValidMaximumLogFileSize(void);
   void __fastcall ReadRegistry(void);
   void __fastcall WriteRegistry(void);
   bool __fastcall Save();
public:		// User declarations
    __fastcall TFormConf(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TFormConf *FormConf;
//---------------------------------------------------------------------------
#endif
