//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "..\TFServer\ivr_defs.h"	// DEFAULT_IVR_PORT
#include "conf_main.h"					// TFCONFIG_REG_KEY
#include "dl_advanced.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormAdvanced *FormAdvanced;
//---------------------------------------------------------------------------
__fastcall TFormAdvanced::TFormAdvanced(TComponent* Owner)
	: TForm(Owner)
{
	ReadRegistry();
}
//---------------------------------------------------------------------------

void __fastcall TFormAdvanced::OKButtonClick(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------

void __fastcall TFormAdvanced::CancelButtonClick(TObject *Sender)
{
	// Restore original values
	efMonitorPort->Text = originalMonitorPort;
	efMonitorHTTPPort->Text = originalMonitorHTTPPort;
   efINIFile->Text = originalINIFile;

	Close();
}
//---------------------------------------------------------------------------
void __fastcall TFormAdvanced::btnINIFileClick(TObject *Sender)
{
   dlgOpen->FileName = "";
   dlgOpen->Title = "Select .INI file";
   dlgOpen->Filter = ".INI File (*.ini)|*.INI|"
                     "All Files (*.*)|*.*";
   dlgOpen->Options.Clear();
   dlgOpen->Options << ofFileMustExist << ofHideReadOnly << ofNoChangeDir;

   if (dlgOpen->Execute()) {
      efINIFile->Text = dlgOpen->FileName;
   }
}
//---------------------------------------------------------------------------

void __fastcall TFormAdvanced::FormActivate(TObject *Sender)
{
	originalMonitorPort = efMonitorPort->Text;
	originalMonitorHTTPPort = efMonitorHTTPPort->Text;
   originalINIFile = efINIFile->Text;
}
//---------------------------------------------------------------------------

void __fastcall TFormAdvanced::ReadRegistry(void)
{
   LONG  ret;
   HKEY  hkey;
   DWORD dwLen = sizeof(DWORD);
   DWORD dwType;
   DWORD dwValue;
   char* pszValue;

   try
   {
   	ret = RegOpenKeyEx(HKEY_LOCAL_MACHINE, TFCONFIG_REG_KEY, 0, KEY_READ, &hkey);

      if(ret != ERROR_SUCCESS)
      {
      	Application->MessageBox("Failed to create registry key.", "Registry Save Failed", MB_ICONERROR | MB_OK);
      }
      else
      {
         // Get MonitorHTTPPort from registry
      	ret = RegQueryValueEx(hkey, "MonitorHTTPPort", NULL, &dwType, (LPBYTE) &dwValue, &dwLen);
         if(ret == ERROR_SUCCESS)
         {
         	efMonitorHTTPPort->Text = dwValue;
         }
         // Default value if registry key doesn't exists or can't be read
         else
         {
         	efMonitorHTTPPort->Text = DEFAULT_IVR_PORT + 1;
         }

         // Get MonitorPort from registry
      	ret = RegQueryValueEx(hkey, "MonitorPort", NULL, &dwType, (LPBYTE) &dwValue, &dwLen);
         if(ret == ERROR_SUCCESS)
         {
         	efMonitorPort->Text = dwValue;
         }
         // Default value if registry key doesn't exists or can't be read
         else
         {
         	efMonitorPort->Text = DEFAULT_IVR_PORT;
         }

         // Get length of LogDirectory string in registry
         ret = RegQueryValueEx(hkey, "INIFile", NULL, &dwType, NULL, &dwLen);
         if(ret == ERROR_SUCCESS)
         {
         	// Create copy of string
            pszValue = new char[dwLen + 1];
            ret = RegQueryValueEx (hkey, "INIFile", NULL, &dwType, pszValue, &dwLen);

            // Copy string to LogDirectory text box
            if(ret == ERROR_SUCCESS)
            {
            	efINIFile->Text = pszValue;
            }

            delete[] pszValue;
         }
         // Default value if registry key doesn't exists or can't be read
         else
         {
         	efINIFile->Text = "";
         }
      }
   }

   catch(Exception &e)
   {
      Application->MessageBox(e.Message.c_str(), "ReadRegistry", MB_OK | MB_ICONERROR);
   }
}




