#include "step_appcall.h"

StepAppCall::StepAppCall(STEPREC& stepRecord) : Step(stepRecord)
{
   appName = stepRecord.s2.arr;
   parmList = stepRecord.s6.arr;
}

StepAppCall::~StepAppCall(void)
{
}

const char* StepAppCall::GetStepName(void) const
{
	return("Run Flowchart");
}

const char* StepAppCall::GetParmList(void) const
{
   return(parmList.c_str());
}

// --------------------------------------------------------------------------
//   Name:        StepAppCall::Execute
//
//   Purpose:     Starts a new application (as opposed to "call").  Does not
//                add on to the LoopQ return stack.
//
//   Questions:   - How does this work?  A TAP file loads all
//   ------------------------------------------------------------------------
IV_STATUS StepAppCall::Execute(PIVRINFO pInfo)
{
   char* value;

   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

   if((value = pInfo->variables->ParseParameter("Flowchart", appName.c_str())) == NULL)
   {
      return(IVR_FATAL);
   }

   SetNextTAMName(value);

   delete[] value;

   return(IVR_APPCALL);
}
