#include "step_beep.h"
#include "..\BoardDLLs\brd_generic.h"

StepBeep::StepBeep(STEPREC& stepRecord) : Step(stepRecord)
{
   interruptable = (bool) stepRecord.u1;
}

StepBeep::~StepBeep(void)
{
}

const char* StepBeep::GetStepName(void) const
{
	return("Beep");
}

IV_STATUS StepBeep::Execute(PIVRINFO pInfo)
{
   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

	if(PortRequired(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FATAL);
   }

   return(pInfo->ivBoard->AudioBeep(interruptable));
}
