#include "step_generatetones.h"
#include "..\BoardDLLs\brd_generic.h"

StepGenerateTones::StepGenerateTones(STEPREC& stepRecord) : Step(stepRecord)
{
   tones = stepRecord.s1.arr;
}

StepGenerateTones::~StepGenerateTones(void)
{
}

const char* StepGenerateTones::GetStepName(void) const
{
	return("Send TT");
}

IV_STATUS StepGenerateTones::Execute(PIVRINFO pInfo)
{
   IV_STATUS status;
   char* value;

   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

	if(PortRequired(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FATAL);
   }

   if((value = pInfo->variables->ParseParameter("Touch tones to generate", tones.c_str())) == NULL)
   {
      return(IVR_FATAL);
   }

   pInfo->ivLog->Print("      Tones: '%s'\n", value);

   status = pInfo->ivBoard->GenerateDigits(value);
   delete[] value;

   return(status);
}
