#ifndef STEP_SENDEMAIL_H
#define STEP_SENDEMAIL_H

#include "..\inet\SMTPTransaction.h"
#include "step.h"

class StepSendEmail : public Step
{
   public:

      enum AUTHENTICATION_TYPE
      {
         NONE = 0,
         LOGIN = 1,
         PLAIN = 2
      };

      StepSendEmail(STEPREC& stepRecord);
      virtual ~StepSendEmail(void);

      const char* GetStepName(void) const;

      IV_STATUS Execute(PIVRINFO pInfo);

   protected:

      string server;
      string account;
      string password;
      StepSendEmail::AUTHENTICATION_TYPE authenticationType;
      string fromAddress;
      string recipients;
      string subject;
      string body;
      string attachments;
      HANDLE waitObjs[2];
      SMTPTransaction* smtp;

      string RemoveComments(string list);
      string CleanUpAddressList(string list);
      string EncodeQuotedPrintable(string text);
      string EncodeBase64(const char* text, unsigned int length);
      string EncodeBase64(FILE* file);
      string GenerateBoundary(void);
      bool NeedsMIME(string& text);
      IV_STATUS GetSMPTPReply(PIVRINFO pInfo);
      string DetermineFileType(string FileName);
};

#endif
