#ifndef STEP_SIMPULLREQUEST_H
#define STEP_SIMPULLREQUEST_H

#include <time.h>

#include "step.h"
#include "..\xmlutil\xmllist.h"

class StepSimpullXMLReq : public Step
{
   public:

      StepSimpullXMLReq(STEPREC& stepRecord);
      virtual ~StepSimpullXMLReq(void);

		const char* GetStepName(void) const;

      IV_STATUS Execute(PIVRINFO pInfo);

   protected:

      // Step fields:
      string handle;          // S01: TeleFlow handle number (1-9)
      string timeout;         // S02: Time to wait for server to respond
      string XMLServer;       // S03: XML server to send request to
      string function;        // S04: Function to call (as defined by SAS_XML spec)
      string params;          // S06: Parameters to pass to XML function call
      string connectTimeout;  // S05: Initial connection retries
      string connectRetries;  // S07: Initial connection retries
      string scriptCode;      // S08: Script to play while waiting (optional)

      char* ComposeParams(const char* pszText, PIVRINFO pInfo);
      char* BuildHash(const char* pszSecret,
                      const char* pszUID,
                      const char* pszPID,
                      const char* pszTime);
};

#endif
