// #include <stdlib.h>             // Needed for "atoi".
#include "step_switchdiscon.h"
#include "..\BoardDLLs\brd_generic.h"


StepSwitchDiscon::StepSwitchDiscon(STEPREC& stepRecord) : Step(stepRecord)
{
}

StepSwitchDiscon::~StepSwitchDiscon(void)
{
}

const char* StepSwitchDiscon::GetStepName(void) const
{
    return("Switch Disconnect");
}

IV_STATUS StepSwitchDiscon::Execute(PIVRINFO pInfo)
{
   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

	if(PortRequired(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FATAL);
   }

   // Call board function to disconnect a previous connection
   // -------------------------------------------------------
   return(pInfo->ivBoard->UnSwitch());
}
