//---------------------------------------------------------------------------
#ifndef moneventH
#define moneventH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include "..\inet\inet_msg.h"
#include "..\escutil\link.h"

#define WM_SOCKET_EVENT  (WM_APP + 400)

/* -------------------------------------------------------------------------
   ------------------------------------------------------------------------- */
typedef struct
{
   NET_MSG   msg;
   int       msgRemaining;
   void     *msgPtr;
   void     *clientData;
   int       dataRemaining;
   void     *dataPtr;
} READ_INFO;

/* -------------------------------------------------------------------------
   ------------------------------------------------------------------------- */
class SendData : public Link
{
public:
   char  *buf;
   char  *sendPtr;
   int    remaining;

   SendData (void *data, int dataSize);
   ~SendData();
};

//---------------------------------------------------------------------------
class MonEvent : public TThread
{
private:
    HANDLE         hTimer;
    HANDLE         waitObjs[3];
    NET_STORAGE    p;
    READ_INFO      readInfo;
    bool           bReplyPending;
    bool           bReconnect;
    int            iError;
    LARGE_INTEGER  waitTimeout;
    char*          host;
    void __fastcall ConnectionFailed();
    void __fastcall ConnectionOpen();
    void __fastcall RequestUpdate (bool bRefresh);
    bool __fastcall HandleRead();
    bool __fastcall HandleWrite();
    void __fastcall ProcessUpdate();
    void __fastcall SayGoodnight();
    void __fastcall ProcessMessages();
    void __fastcall DisplayError (int error);
    void __fastcall SyncDisplayError();
protected:
    void __fastcall Execute();
public:
    Head           myQueue;
    HANDLE      hCloseEvent;   // Signalled to terminate socket monitor thread.
    __fastcall MonEvent (char *pszHost, int port);
    __fastcall ~MonEvent();
};
//---------------------------------------------------------------------------
#endif
