#ifndef TFENGINE_COMMUNICATION_MANAGER_H
#define TFENGINE_COMMUNICATION_MANAGER_H

#include "..\TFServer\communication_hub.h"         // CommunicationDestination, CommunicationHub
#include "..\TFEngine\TFEngine_communication.h"    // TFEngineCommunicationPacket
#include "..\TFServer\TFServer_communication.h"    // TF_DESTINATION_ID

// Manages messages to engines
// Note that messages must be TFEngineCommunicationPackets
// Messages for engines must use TF_ENGINE_MANAGER as their destination
// Messages with a appID of 0 indicate a broadcast to all engines
class TFEngineCommunicationManager : public CommunicationDestination<TFServerCommunicationPacket::TF_DESTINATION_ID>, public CommunicationHub<int>
{
   public:

      TFEngineCommunicationManager(void);

      void BroadcastMessage(TFEngineCommunicationPacket* message);
      TFServerCommunicationPacket::TF_DESTINATION_ID ID(void);
      bool SendMessage(CommunicationPacket* message);
};

#endif
