#ifndef _SIMSHARED_H
#define _SIMSHARED_H

#include <winbase.h> // CRITICAL_SECTION

#include "..\BoardDLLs\brd_simulator_code.h" // SIMULATOR_EVENT

struct SimulatorShared
{
   Mutex mutex;

   SignalQueue<SIMULATOR_EVENT> eventQueue;	// Queue for Simulator events.
   SignalQueue<char> ttPendingQueue;   		// Queue for touch tones before SIMEVT_DIGIT is processed

   HANDLE unpaused;
   bool readyForCall;               // Board is ready to accept call (currently in WaitForCall step)
   HANDLE connected;                // Board and TFSimulator are connected
   HANDLE outgoingCall;             // Signal TFSimulator that board is placing a call
   HANDLE outgoingCallConnected;    // Signal TFSimulator that placed call connected
   HANDLE enableStopRecordButton;   // Signal TFSimulator to enable the Stop Record button
   HANDLE refresh;                  // Signal TFSimulator to repaint

   DWORD shortAudioPrompts;
   LONG mciDevice;
   HWAVEIN hwi;
   HANDLE handle;                            // Handle to Simulator windows for MCI messages

   long stepNo;                                    // Current step number.
   char currentTAMName[TELEFLOW_TAM_NAME_MAX + 1]; // Current procedure.
   char stepName[TELEFLOW_STEP_NAME_MAX + 1];      // Step name (e.g. "Wait For Call").
   char status;                                    // Application status.

   GUILog* ivLog;
};
#endif

 