#ifndef WAITTIMER_H
#define WAITTIMER_H

#include <winsock2.h>
#include <windows.h>	// LONGLONG, HANDLE, LARGE_INTEGER

#if defined (__DLL__)
#define WAITAPI __declspec(dllexport)
#else
#define WAITAPI __declspec(dllimport)
#endif

// waitTimeout is measured in 100 nanosecond intervals (10^-7 = .0000001).
// To convert to milliseconds times by 10,000 (.001 = 10^-3 = 10^-7 x 10^4).
#define SetTimeoutMS(timer, timeout) \
           timer.QuadPart = -(LONGLONG)(timeout * 10000)

// waitTimeout is measured in 100 nanosecond intervals (10^-7 = .0000001).
// To convert to seconds times by 10,000,000 (1 = 10^0 = 10^-7 x 10^7).
#define SetTimeoutSEC(timer, timeout) \
           timer.QuadPart = -(LONGLONG)(timeout * 10000000)

class WAITAPI WaitTimer
{
public:
   WaitTimer (bool bManualReset = false);
   ~WaitTimer();

   void SetTimeoutInSeconds (int iSeconds);
   void SetTimeoutInMilliseconds (int iMilliseconds);
   void Start();
   void StartSec (int iSeconds);
   void StartMS (int iMilliseconds);
   void Cancel();
   HANDLE GetHandle();

private:
   bool           m_bManualReset;
   HANDLE         m_hWaitTimer;
   LARGE_INTEGER  m_waitTimeout;

   // Prevent copying and assignment.
   WaitTimer (const WaitTimer&);
   WaitTimer& operator= (const WaitTimer&);
};

#undef WAITAPI

#endif
