#ifndef __HTTPTRANSACTION_H__
#define __HTTPTRANSACTION_H__

#ifdef __DLL__
#define HTTPTRANSACTIONAPI __declspec(dllexport)
#else
#define HTTPTRANSACTIONAPI __declspec(dllimport)
#endif

#include <string>
using std::string;

#include "InternetMessageTCPTransaction.h"
#include "HTTPRequest.h"
#include "HTTPResponse.h"

class HTTPTRANSACTIONAPI HTTPTransaction : public InternetMessageTCPTransaction
{
   public:

      HTTPTransaction(const char* url = NULL, bool persistant = false);
      HTTPTransaction(ACE_HANDLE handle, const char* url = NULL);
      virtual ~HTTPTransaction(void);

      virtual const char* GetURL(void);
      virtual void SetPeerName(const char* name);
      virtual void SetPeerPort(unsigned short port);
      virtual HTTPRequest* Request(void);
      virtual HTTPResponse* Response(void);
      virtual void SetURL(const char* url);

   protected:

      virtual void ConstructURL(void);

      string url;
};

#endif

