#include "InternetMessageUDPTransaction.h"

InternetMessageUDPTransaction::InternetMessageUDPTransaction(unsigned short port, bool persistant) : UDPSocket(port, persistant)
{
   request = NULL;
   response = NULL;
}

InternetMessageUDPTransaction::InternetMessageUDPTransaction(ACE_HANDLE handle) : UDPSocket(handle)
{
   request = NULL;
   response = NULL;
}

InternetMessageUDPTransaction::~InternetMessageUDPTransaction(void)
{
}

int InternetMessageUDPTransaction::Send(const ACE_Addr& peer)
{
   int ret;

   Response()->ClearText();

   if((ret = SendBytes(Request()->GetText(), strlen(Request()->GetText()), peer)) != Socket::SUCCESS)
   {
      Response()->SetText(Socket::WSAErrorString(errno));
   }

   return(ret);
}

int InternetMessageUDPTransaction::Receive(ACE_Addr& peer)
{
   const char* responseText;
   int ret;

   if((ret = ReceiveString(responseText, peer)) == Socket::SUCCESS)
   {
      Response()->AddText(responseText);
   }
   else
   {
      Response()->SetText(Socket::WSAErrorString(errno));
   }

   return(ret);
}

InternetMessage* InternetMessageUDPTransaction::Request(void)
{
   return(request);
}

InternetMessage* InternetMessageUDPTransaction::Response(void)
{
   return(response);
}
