#ifndef __SMTPREQUEST_H__
#define __SMTPREQUEST_H__

#ifdef __DLL__
#define SMTPREQUESTAPI __declspec(dllexport)
#else
#define SMTPREQUESTAPI __declspec(dllimport)
#endif

#include "InternetMessage.h"

class SMTPREQUESTAPI SMTPRequest : public InternetMessage
{
   public:

      // Format: "CCCCC AAAAAAAA\r\n"
      // where CCCCC is the command, and AAAAAAAA are the arguments

      // Clears the command
      // Clears the arguments
      SMTPRequest(void);

      virtual ~SMTPRequest(void);

      // Adds text to end of arguments
      // Has no effect if text is NULL
      virtual void AddArguments(const char* text);

      // Sets arguments to text
      // Clears arguments if text is NULL
      virtual void SetArguments(const char* text);

      // Sets command
      // Clears command if text is NULL
      virtual void SetCommand(const char* text);
};

#endif

